<?php

if( !class_exists('FV_Player_Pro') ) :

include( dirname(__FILE__).'/rcp-bridge.php' );
include( dirname(__FILE__).'/s3.class.php' );
include( dirname(__FILE__).'/ads.exoclick.class.php' );
include( dirname(__FILE__).'/download.class.php' );
include( dirname(__FILE__).'/amazon-drive.class.php' );
include( dirname(__FILE__).'/ajax-loader.class.php' );
include( dirname(__FILE__).'/bunnycdn.class.php' );
include( dirname(__FILE__).'/keycdn.class.php' );
include( dirname(__FILE__).'/stackpath.class.php' );

class FV_Player_Pro {
  
  var $version = '6.6.3.1';
  
  var $autoplay_count = 0;

  var $license_key = false;
  
  var $aChapters = array();
  
  var $aStartEnd = array();
  
  var $aVideoAds = array();
  
  var $aVimeoQualities = array( '-mobile' => '240p', '-mobile2' => '270p', '-sd' => '360p', '-md' => '540p', '-hd' => '720p', '-fullhd' => '1080p', '-qhd' => '1440p', '-4k' => '2160p' );
  
  var $aYouTubeQualities = array( 'large' => 'SD', 'hd720' => 'HD', 'small' => 'Mobile' );
  
  var $bDynamic = false;
  
  var $bVideoAdsStatus = array();
  
  var $bYoutube = false;
  
  var $htmlAfter = '';

  var $aFrontendErrors = array();

  var $fTimeSpent_AutoSplash = 0;
  
  var $iLoadingRecursion = 0;
    
  function __construct() {
    $flowplayer_opt = get_option('fvwpflowplayer');
    $this->license_key = ( isset($flowplayer_opt['key']) && !empty($flowplayer_opt['key']) ) ? $flowplayer_opt['key'] : false;
    
    add_filter( 'fv_flowplayer_get_mime_type', array( $this, 'set_file_type'), 10, 2 );
    add_filter( 'fv_flowplayer_player_type', array( $this, 'set_player_type' ), 10, 5 );  //  switch FV Flowplayer not to use the iframe Vimeo integration
    
    add_action( 'wp_enqueue_scripts', array( $this, 'styles' ), 11 );
    add_action( 'wp_footer', array( $this, 'styles' ) ); // sometimes FV Player styles load in footer
    add_action( 'wp_footer', array( $this, 'scripts' ), 0 );
    
//    add_action( 'wp_ajax_nopriv_fv_fp_get_vimeo', array( $this, 'ajax__get_vimeo' ) );
//    add_action( 'wp_ajax_fv_fp_get_vimeo', array( $this, 'ajax__get_vimeo' ) );
    if( isset($_POST['action']) && $_POST['action'] === 'fv_fp_get_vimeo' ) {
      add_action( 'plugins_loaded', array( $this, 'ajax__get_vimeo' ) );  //  todo: speed up?
    }

//    add_action( 'wp_ajax_nopriv_fv_fp_get_video_url', array( $this, 'ajax__get_video_url' ) );
//    add_action( 'wp_ajax_fv_fp_get_video_url', array( $this, 'ajax__get_video_url' ) );
    if( isset($_POST['action']) && $_POST['action'] === 'fv_fp_get_video_url' ) {
      add_action( 'plugins_loaded', array( $this, 'ajax__get_video_url' ) );  //  todo: speed up?
    }
    
//    add_action( 'wp_ajax_nopriv_fv_fp_secure_hls_cookie', array( $this, 'ajax__get_secure_hls_cookie' ) );
//    add_action( 'wp_ajax_fv_fp_secure_hls_cookie', array( $this, 'ajax__get_secure_hls_cookie' ) );
    if(isset($_POST['action']) && $_POST['action'] === 'fv_fp_secure_hls_cookie'){
      add_action( 'plugins_loaded', array( $this, 'ajax__get_secure_hls_cookie' ) );
    }
    
    add_action( 'wp_ajax_fv_fp_decrypt_hlskey', array( $this, 'ajax__get_decrypt_hlskey' ) );
    add_action( 'admin_enqueue_scripts', array( $this, 'admin_enqueue_scripts' ) );
    add_action( 'fv_flowplayer_shortcode_editor_after', array( $this, 'shortcode_editor_actions' ) );    
    add_action( 'fv_flowplayer_shortcode_editor_tab_options', array( $this, 'shortcode_editor_options' ) );
    add_action( 'fv_flowplayer_shortcode_editor_item_after', array( $this, 'shortcode_editor_item' ) );
    add_filter( 'fv_flowplayer_shortcode', array( $this, 'shortcode' ), 10, 3 );

    add_filter( 'fv_flowplayer_buttons_left', array( $this, 'ab_loop_buttons' ) );
    add_filter( 'fv_flowplayer_buttons_left', array( $this, 'hflip_button' ) );
    add_filter( 'fv_flowplayer_buttons_right', array( $this, 'quality_buttons' ) );
    add_filter( 'fv_flowplayer_inner_html', array( $this, 'ab_loop_html' ), 10, 2 );
    
    add_filter( 'fv_flowplayer_attributes', array( $this, 'quality_attributes' ), 10, 3 );
    add_filter( 'fv_flowplayer_attributes', array( $this, 'start_stop_attributes' ), 10, 3 );
    
    add_filter( 'fv_flowplayer_attributes', array( $this, 'copy_text_attributes' ), 10, 3 );
    
    add_filter( 'fv_flowplayer_attributes', array( $this, 'secure_hls_attributes' ), 12, 2 );
    add_filter( 'fv_flowplayer_args_pre', array( $this, 'secure_hls_stop_autoplay' ), 9, 2 );
    
    
    add_filter( 'fv_player_media', array( $this, 'quality_media' ), 10, 2 );
    add_filter( 'fv_player_media_rtmp', array( $this, 'quality_media' ), 10, 2 );
    
    add_filter( 'fv_flowplayer_html', array( $this, 'chapters_html' ), 10, 2 );
    add_filter( 'fv_flowplayer_html', array( $this, 'transcript_html' ), 11, 2 );
    
    add_filter( 'fv_flowplayer_video_src', array( $this, 'get_cloudfront_secure'), 10, 2 );
    add_filter( 'fv_flowplayer_splash', array( $this, 'get_cloudfront_secure_url') );
    add_filter( 'fv_flowplayer_playlist_splash', array( $this, 'get_cloudfront_secure_url') );
    add_filter( 'fv_flowplayer_resource', array( $this, 'get_cloudfront_secure_url') );
    
    add_filter( 'fv_flowplayer_shortcode', array( $this, 'vimeo_channel' ), 10, 3 );
    add_filter( 'fv_flowplayer_shortcode', array( $this, 'youtube_channel' ), 10, 3 );
    
    if( !is_admin() ) {
      add_filter( 'fv_flowplayer_splash', array( $this, 'get__cached_splash' ) );
      add_filter( 'fv_flowplayer_playlist_splash', array( $this, 'get__cached_splash' ), 10, 3 );      
      add_filter( 'fv_flowplayer_splash', array( $this, 'youtube_splash' ) );
      add_filter( 'fv_flowplayer_playlist_splash', array( $this, 'youtube_splash' ), 10, 3 );
    }
    		
    add_filter( 'plugin_action_links', array( $this, 'admin__plugin_action_links' ), 10, 2);
    add_action( 'admin_menu', array($this, 'admin__menu'), 11 );
    add_filter( 'fv_flowplayer_settings_save', array($this, 'settings_save'), 10, 2 );
    
    add_filter( 'content_save_pre', array($this, 'save_post'), 10 );  //  exp: downside - it's called twice on post save
    
    add_action( 'admin_init', array( $this, 'admin__add_meta_boxes' ) );
    add_action( 'admin_init', array( $this, '_get_conf' ) );
    add_action( 'admin_notices', array( $this, 'admin__version_check') );
    add_action( 'admin_notices', array( $this, 'convert__start') );
    add_action( 'admin_footer-plugins.php', array( $this, 'disable_deactivate_fv_player') );
        
    add_action( 'admin_notices', array( $this, 'vimeo_key_check_note') );
    
    add_filter( 'fv_flowplayer_checker_time', array( $this, 'youtube_duration' ), 10, 2 );
    
    add_action( 'wp_ajax_fv_foliopress_ajax_pointers', array( $this, 'ajax__pointers' ) );
    
    add_filter( 'fv_flowplayer_playlist_items', array( $this, 'start_endtime' ), 10, 2 ); //  old_code
    
    add_filter( 'fv_flowplayer_playlist_items', array( $this, 'video_ads' ), 10, 2 );
    add_filter( 'fv_flowplayer_playlist_item_html', array( $this, 'video_ads_item_html') ); 
    add_filter( 'fv_flowplayer_html', array( $this, 'append_warnings'), 999 );   
    
    add_action('amp_post_template_css', array( $this, 'amp_post_template_css' ) );
    add_action('amp_post_template_footer', array( $this, 'amp_post_template_footer' ), 9 );


    //add_filter( 'the_content', array($this,'convert__vimeo_callback') );
    $this->secure_hls_key_send();

    // Localization phrases
    add_action( 'plugins_loaded', array( $this, 'init_plugin_textdomain' ) );

    $version = get_option( 'fv_player_pro_ver' );
    if( $this->version != $version ) {
      update_option( 'fv_player_pro_ver', $this->version );
      $this->plugin_update_database();
    }
            
    add_action( 'fv_player_pro_clear_cache', array( $this, 'clear_cache' ) );
    add_action( 'admin_init', array( $this, 'cron_init' ) );
    
    add_filter( 'fv_flowplayer_args', array( $this, 'disable_titles_vimeo_youtube') );
    
    add_action( 'fv_flowplayer_admin_interface_options_after', array( $this, 'interface_options'), 11 );

    add_filter( 'fv_player_item', array($this, 'item_chapters'), 10, 3);
    add_filter( 'fv_player_item', array($this, 'item_start_end'), 10, 3);
    
    add_action( 'shutdown', array( $this, 'vimeo_mpd_htaccess') );
  }

  public function _get_conf() {
    global $fv_fp;
    if( !isset($fv_fp->conf) )
      return false;

    $conf = get_option( 'fvwpflowplayer' );

    if(!isset($conf['pro'])) $conf['pro'] = array();

    if(empty($conf['pro']['quality'])) $conf['pro']['quality'] = ',';

    if(empty($conf['pro']['video_ads_default'])) $conf['pro']['video_ads_default'] = 'no';
    if(empty($conf['pro']['video_ads_postroll_default'])) $conf['pro']['video_ads_postroll_default'] = 'no';
    if( !isset($conf['pro']['video_ads_skip']) || !is_numeric($conf['pro']['video_ads_skip']) ) $conf['pro']['video_ads_skip'] = 5;
    if( !isset($conf['pro']['video_ads_skip_minimum']) || !is_numeric($conf['pro']['video_ads_skip_minimum']) ) $conf['pro']['video_ads_skip_minimum'] = 10;


    update_option( 'fvwpflowplayer', $conf );
    $fv_fp->conf = $conf;
    return true;
  }



  function is_option_enabled( $option = false ) {
    if( !$option ) {
      return false;
    }

    global $fv_fp;
    if( is_array($option) && count($option) == 2 && isset($fv_fp->conf['pro']) && isset($fv_fp->conf['pro'][$option[0]]) && isset($fv_fp->conf['pro'][$option[0]][$option[1]]) && $fv_fp->conf['pro'][$option[0]][$option[1]] == 'true' ) {
      return true;
    } else if( !is_array($option) && isset($fv_fp->conf['pro']) && is_array($fv_fp->conf['pro']) && isset($fv_fp->conf['pro'][$option]) && strcmp($fv_fp->conf['pro'][$option],'false') != 0 ) {
      return true;
    } else {
      return false;
    }

  }

  public function _get_option($key) {
    global $fv_fp;
    if( !isset($fv_fp) ) return false;
    
    $value = $fv_fp->conf;
    if(is_string($key)){
      $key = array($key);
    }
    foreach($key as $val){
        $value = isset($value[$val]) ? $value[$val] : false;
    }

    if( is_string($value) ) $value = trim($value);

    if($value === 'false')
      $value = false;
    else if($value === 'true')
      $value = true;

    return $value;
  }

  public function _get_checkbox( $name, $key, $help = false, $more = false ) {
    $checked = $this->_get_option($key);
    if($checked === 'false' ) $checked = false;
    if( is_array($key) && count($key) > 1 ) {
      $key = $key[0] . '[' . $key[1] . ']' . (isset($key[2]) ? '[' . $key[2] . ']' : '');
    }
    ?>
      <tr>
        <td class="first"><label for="<?php echo $key; ?>"><?php echo $name; ?>:</label></td>
        <td>
          <p class="description">
              <input type="hidden" name="<?php echo $key; ?>" value="false" />
              <input type="checkbox" name="<?php echo $key; ?>" id="<?php echo $key; ?>" value="true" <?php if( $checked ) echo 'checked="checked"'; ?> />
            <?php if( $help ) echo $help; ?>
            <?php if( $more ) : ?>
                <span class="more"><?php echo $more; ?></span> <a href="#" class="show-more">(&hellip;)</a>
            <?php endif; ?>
          </p>
        </td>
      </tr>
    <?php
  }

  function init_plugin_textdomain()
  {
    // plugin_basename( $file ) // https://codex.wordpress.org/Function_Reference/plugin_basename
    // string dirname ( string $path [, int $levels = 1 ] ) // http://php.net/manual/en/function.dirname.php
    load_plugin_textdomain('fv-player-pro', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/'); // $strPluginSlug
  }

  function fv_player_pro_get_js_translations()
  {
    $a_strings = array(
      'ad_duration'         => __('This ad will end in 0 seconds', 'fv-player-pro'),
      'invalid_youtube'     => __('Invalid Youtube video ID.', 'fv-player-pro'),
      'reload_page'         => __('Please reload the page and try again.', 'fv-player-pro'),
      'reload_page_later'   => __('Please reload the page and try again in a couple of minutes. ', 'fv-player-pro'),
      'required_type'       => __('Couldn\'t find the required video type: ', 'fv-player-pro'),
      'skip_ad'             => __('Skip', 'fv-player-pro'),
      'cva_contiunue'       => __('Continue to video', 'fv-player-pro'),
      'cva_visit'           => __('Visit advertiser', 'fv-player-pro'),
      'video_decryption_e'  => __('Video Decryption Error', 'fv-player-pro'),
      'video_expired'       => __('Video file expired.<br />Please reload the page and play it again.', 'fv-player-pro'),
      'video_loaded'        => __('Video loaded, click to play.', 'fv-player-pro'),
      'old_android'         => __('Your old Android device doesn\'t support this video type.', 'fv-player-pro'),
      'ab_loop'             => __("Tip: Use 'i' and 'o' keys for precise loop selection", 'fv-player-pro'),
      'ab_loop_start'             => __("Loop start set", 'fv-player-pro'),
      'ab_loop_end'             => __("Loop end set", 'fv-player-pro'),
    );
    
    return $a_strings;
  }




  function ab_loop_buttons($aButtons) {
    global $fv_fp;
    
    if ((isset($fv_fp->aCurArgs['ab']) && $fv_fp->aCurArgs['ab'] === 'true' || empty($fv_fp->aCurArgs['ab']) && $this->_get_option( array('pro','ab_loop') ) )
        && (isset($fv_fp->aCurArgs['controlbar']) && $fv_fp->aCurArgs['controlbar'] != 'no' || !isset($fv_fp->aCurArgs['controlbar']) )) {
      $aButtons[] = "<ul class='fv-player-loop'><li><a href='#'>" . __('AB Loop', 'fv-player-pro') . "</a></li></ul>";
    }

    return $aButtons;
  }




  function ab_loop_html($sHTML) {

    $aArgs = func_get_args();
    if (isset($aArgs[1]->aCurArgs['ab']) && $aArgs[1]->aCurArgs['ab'] === 'true' || empty($aArgs[1]->aCurArgs['ab']) && $this->_get_option( array('pro','ab_loop') )) {
      $sOutput = "<div class='fv-ab-loop'><div></div></div>";
      $sHTML .= $sOutput;
    }

    return $sHTML;
  }
  
  
  
  
  function admin_enqueue_scripts( $page ) {
    if( $page == 'post.php' || $page == 'post-new.php' ) {
      wp_register_script('fvplayer-shortcode-editor-pro', plugins_url('js/shortcode-editor-pro.js',__FILE__),array('jquery','fvwpflowplayer-shortcode-editor'), $this->version );  
      wp_enqueue_script('fvplayer-shortcode-editor-pro');
    }
  }
  
  
  
  
  function admin__add_meta_boxes() {
    global $fv_wp_flowplayer_ver;
    $bSettingsTabs = version_compare($fv_wp_flowplayer_ver,'6.0.5.4') == 1;
    
    if($bSettingsTabs){
      //Basic tab
      add_meta_box( 'fv_player_pro', __('Pro Features', 'fv-player-pro'), array( $this, 'fv_player_admin_pro' ), 'fv_flowplayer_settings', 'normal', 'low' );
      add_meta_box( 'fv_player_pro_quality', __('Quality Switching', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_quality' ), 'fv_flowplayer_settings', 'normal', 'low' );
      add_meta_box( 'fv_player_pro_drm_text', __('DRM Text', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_drm_text' ), 'fv_flowplayer_settings', 'normal', 'low' );
      
      //Hosting Tab
      add_meta_box( 'fv_player_pro_cloudfront', __('CloudFront (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_cloudfront' ), 'fv_flowplayer_settings_hosting', 'normal', 'low' );
      add_meta_box( 'fv_player_pro_vimeo', __('Vimeo (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_vimeo' ), 'fv_flowplayer_settings_hosting', 'normal' );
      add_meta_box( 'fv_player_pro_youtube', __('YouTube (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_youtube' ), 'fv_flowplayer_settings_hosting', 'normal' );
      add_meta_box( 'fv_player_pro_aws_decoder', __('Amazon AWS Decoder (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_aws_decoder' ), 'fv_flowplayer_settings_hosting', 'normal', 'low' );

      //Video Ads Tab
      add_meta_box( 'fv_player_pro_video_ads_description', ' ', array( $this, 'fv_player_admin_pro_video_ads_description' ), 'fv_flowplayer_settings_video_ads', 'normal' ,'high');
      add_meta_box( 'fv_player_pro_video_ads', __('Video Ads (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_video_ads' ), 'fv_flowplayer_settings_video_ads', 'normal', 'low' );
    }else{
      add_meta_box( 'fv_player_pro', __('Pro Features', 'fv-player-pro'), array( $this, 'fv_player_admin_pro' ), 'fv_flowplayer_settings', 'normal', 'low' );
      add_meta_box( 'fv_player_pro_cloudfront', __('CloudFront (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_cloudfront' ), 'fv_flowplayer_settings', 'normal', 'low' );
      add_meta_box( 'fv_player_pro_quality', __('Quality Switching', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_quality' ), 'fv_flowplayer_settings', 'normal', 'low' );
      add_meta_box( 'fv_player_pro_video_ads', __('Video Ads (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_video_ads' ), 'fv_flowplayer_settings', 'normal', 'low' );
      add_meta_box( 'fv_player_pro_vimeo', __('Vimeo (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_vimeo' ), 'fv_flowplayer_settings', 'normal', 'low' );
      add_meta_box( 'fv_player_pro_youtube', __('YouTube (Pro)', 'fv-player-pro'), array( $this, 'fv_player_admin_pro_youtube' ), 'fv_flowplayer_settings', 'normal', 'low' );
    }
    
    /*global $fv_fp;
    if( $this->_get_option( array('pro','youtube') ) !== true ) {
      $fv_fp->pointer_boxes['fv_flowplayer_pro_youtube'] = array(
        'id' => '#wp-admin-bar-new-content',
        'pointerClass' => 'fv_flowplayer_pro_youtube',
        'pointerWidth' => 340,
        'heading' => __('FV Player Pro YouTube', 'fv-player-pro'),
        'content' => __('YouTube videos are now automatically using the advanced embedding.<!--<br /><br />If you need to use the standard YouTube iframe embeds, disable the YouTube integration in the', 'fv-player-pro') . ' <a href="' . site_url('wp-admin/options-general.php?page=fvplayer#fv_player_pro_youtube') . '">' . __('Youtube Settings', 'fv-player-pro') . '</a>.-->',
        'position' => array( 'edge' => 'top', 'align' => 'center' ),
        'button1' => __('Acknowledge', 'fv-player-pro'),
        'button2' => '<style>.fv_flowplayer_pro_youtube #pointer-close { display: none }</style>'
      );
    }*/
    
  }
  
  function plugin_update_database(){
    
    global $wpdb;

    $charset_collate = $wpdb->get_charset_collate();

    $sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}fv_fp_hls_access_tokens` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
      `url` varchar(100) NOT NULL,
      `client` varchar(100) NOT NULL,
      `cookie` varchar(50) NOT NULL,
      PRIMARY KEY (`id`),
      KEY `url` (`url`),
      KEY `client` (`client`)
    ) $charset_collate;";
    
    $wpdb->query($sql);

    $this->clear_cache(true);
  }
  
  
  function admin__menu() {
    global $submenu;
    if( is_array($submenu) && isset($submenu["options-general.php"]) && is_array($submenu["options-general.php"]) ) {
      $bFound = false;
      foreach( $submenu["options-general.php"] as $key => $aItem ) {
        if( $aItem[2] == 'fvplayer' ) {
          $bFound = true;
          $submenu["options-general.php"][$key][0] = 'FV Player Pro';
          $submenu["options-general.php"][$key][3] = 'FV Player Pro';
        }
      }
      
      if( !$bFound ) {
        add_options_page( 'FV Player Pro', 'FV Player Pro', 'manage_options', 'fvplayer', array($this, 'admin__screen_warn') );
      }
    }
  }
  
  
  
  
  function admin__plugin_action_links($links, $file) {
  	$plugin_file = basename(__FILE__);
  	if( basename($file) == $plugin_file ) {
      $settings_link =  '<a href="'.site_url('wp-admin/options-general.php?page=fvplayer#fv_player_pro').'">'.__('Settings', 'fv-player-pro').'</a>';
  		array_unshift($links, $settings_link);
  	}
  	return $links;
  }

  
  
  
  function admin__screen() {
    //  dummy
  }
  
  
  
  
  function admin__screen_warn() {
    global $fv_fp;    
    if( isset($fv_fp) || $fv_fp ) return;
  
    ?>
    <div class="wrap">
      <div style="position: absolute; margin-top: 10px; right: 10px;">
        <a href="https://foliovision.com/wordpress/plugins/fv-wordpress-flowplayer" target="_blank" title="<?php _e('Documentation', 'fv-player-pro'); ?>"><img alt="visit foliovision" src="//foliovision.com/shared/fv-logo.png" /></a>
      </div>
      <div>
        <div id="icon-options-general" class="icon32"></div>
        <h2>FV Player Pro</h2>
      </div>
      
      <div class="error">
        <p><?php _e('<strong>FV Player</strong> is not installed or activated. Please <a href="plugin-install.php?tab=plugin-information&plugin=fv-wordpress-flowplayer&" target="_blank" title="FV Wordpress Flowplayer install page">install</a> it and enter your FV Flowplayer license key.', 'fv-player-pro'); ?></p>
      </div>
      
    </div>
    <?php
  }
  
  
  
  
  function admin__select_video_ads($aArgs){

    $sId = (isset($aArgs['id'])?$aArgs['id']:'pro[video_ads_default]');
    $aArgs = wp_parse_args( $aArgs, array( 'id'=>$sId, 'cva_id'=>'', 'show_default' => false ) );
    ?>
    <select id="<?php echo $aArgs['id']; ?>" name="<?php echo $aArgs['id']; ?>">
      <?php if( $aArgs['show_default'] ) : ?>
        <option><?php _e('Use site default', 'fv-player-pro'); ?></option>
      <?php endif; ?>
      <option <?php if( $aArgs['cva_id'] == 'no' ) echo 'selected '; ?>value="no"><?php _e('No ad', 'fv-player-pro'); ?></option>
      <option <?php if( $aArgs['cva_id'] == 'random' ) echo 'selected '; ?>value="random"><?php _e('Random', 'fv-player-pro'); ?></option>
      <?php
      $videoAds = $this->_get_option( array('pro','video_ads') );
      if(  is_array($videoAds) && count($videoAds) > 0 ) {
        foreach( $videoAds AS $key => $aVideoAd ) {
          ?><option <?php if( $aArgs['cva_id'] == $key+1 ) echo 'selected'; ?> value="<?php echo $key+1; ?>"><?php
          echo $key+1;
          if( !empty($aVideoAd['name']) ) echo ' - '.$aVideoAd['name'];
          if( $aVideoAd['disabled'] == 1 ) echo ' (currently disabled)';
          if( trim( $aVideoAd['videos']['mp4'] ) === '' ) echo ' (no video URL)';
          ?></option><?php
        }
      } ?>      
    </select>
    <?php
  }
  
  
  function admin__version_check() {
    global $fv_wp_flowplayer_ver;
    if( $fv_wp_flowplayer_ver && version_compare($fv_wp_flowplayer_ver,'6.0.5.13') != 1 ) : 
    ?>
    <div class="error">
        <p><?php _e( 'FV Player Pro: Please upgrade to FV Wordpress Flowplayer version 6.0.5.13 or above!', 'fv-player-pro' ); ?></p>
    </div>
    <?php
    endif;
    
    if( isset($_GET['fv-licensing']) && $_GET['fv-licensing'] == "check" ){
      echo '<div class="updated inline">
              <p>'.__('Thank you for purchase. Your license will be renewed in couple of minutes.<br/>
              Please make sure you upgrade <strong>FV Player Pro</strong> and <strong>FV Player VAST</strong> if you are using it.', 'fv-player-pro').'</p>
            </div>';
    }
  }
  
  function disable_deactivate_fv_player(){
    ?>
      <script>
      jQuery('document').ready(function(){
        jQuery('[data-slug=fv-wordpress-flowplayer] .deactivate>a').click(function(e){
          e.preventDefault();
          if(confirm("<?php _e('The FV Player plugin is essential for FV Player Pro plugin.\nDeactivating it will cause it not to function.\nAre You sure You want to Deactivate it?', 'fv-player-pro'); ?>")){
            location.assign(jQuery(this).attr('href'));
          }
        });
      })
      </script>
    <?php
  }




  function ajax__get_video_url() {
    if( $this->_get_option( array('pro','cf_key_id') ) && $this->_get_option( array('pro','cf_pk') )) {
      echo '<FVFLOWPLAYER>';

      $aRequest = parse_url($_SERVER['HTTP_REFERER']);
      $aHome = parse_url(home_url());      
  
      if( $aRequest['host'] != $aHome['host'] ) {
        echo json_encode( array( 'error' => 'Bad request!' ) );
        die();
      }
      
      $aMP4 = array();
      foreach( $_POST['sources'] AS $key => $value ) {
        if( !isset($value['src']) || !isset($value['type']) ) continue;
        
        if( 1<0 && $value['type'] == "video/flash" ) { //  todo: what about this?
          $bSkip = false;
          foreach( $aMP4 AS $sMP4 ) {
            //  we need to find if the same filename is already signed for mp4 before we create a new signature for flash. For this we strip all but the basic characters and the signature
            if( preg_replace( '~(\?Expires=.+|%[A-Z0-9]{2}|[^a-zA-Z0-9-_])~', '', $sMP4 ) == preg_replace( '~(%[A-Z0-9]{2}|[^a-zA-Z0-9-_])~', '', $value['src'] ) ) { //  todo: unfortunatelly we get the Flash video URL like this - does it work with RTMP though?
              $sMP4 = str_replace('+', '%2B', $sMP4);
              $_POST['sources'][$key]['source'] = $sMP4;  //  v6 check!
              $bSkip = true;
              continue;
            }
          }
          if( $bSkip ) {
            continue;
          }
        }
        
        $value['src'] = $this->get_cloudfront_secure($value['src'], array( 'dynamic' => true, 'flash' => ( $value['type'] == "video/flash" ) ? true : false ) );       
        $_POST['sources'][$key] = $value;
        if( $value['type'] == "video/mp4" ) {
          $aMP4[] = $value['src']; 
        }               


      }

      echo json_encode($_POST['sources']);            
      echo '</FVFLOWPLAYER>';
      if (!defined('PHPUnitTestMode')) {
        exit;
      } else {
        return;
      }
    }
  }

  
  
  
  function ajax__get_vimeo() {
    if( $this->is_option_enabled('vimeo') ) {
      @header( 'Content-Type: application/json; charset=' . get_option( 'blog_charset' ) );
      echo '<FVFLOWPLAYER>';

      $aRequest = parse_url($_SERVER['HTTP_REFERER']);
      $aHome = parse_url(home_url());      
  
      if( $aRequest['host'] != $aHome['host'] ) {
        echo json_encode( array( 'error' => 'Bad request!' ) );
        die();
      }
      
      $aData = $this->func__get_vimeo( $_POST['sources'][0]['src'] );

      if( isset($aData->mpd_backup) ) unset($aData->mpd_backup);

      if( is_object($aData) ) {
        echo json_encode( $aData );
      } else {
        echo json_encode( array( 'error' => 'Unknown error' ) );
      }
      echo '</FVFLOWPLAYER>';
      die();
    }
  }
  
  
  
  
  function ajax__pointers() {
    if( isset($_POST['key']) && isset($_POST['value']) ) {
      if( $_POST['key'] == 'fv_flowplayer_pro_youtube'  ) {
        check_ajax_referer('fv_flowplayer_pro_youtube');
        $conf = get_option( 'fvwpflowplayer' );
        if( $conf ) {
          $conf['pro']['youtube'] = 'true';
          update_option( 'fvwpflowplayer', $conf );
        }
        die();
      }
      
    }    
  }
  
  
  
  
  function amp_post_template_css() {
    $this->styles();
  }
  
  
  
  
  function amp_post_template_footer() {
    $this->scripts();
  }
  
  
  
  
  function append_warnings($sHTML) {
    if( count($this->aFrontendErrors) ) {
      $sHTML .= "<p>".implode( "</p><p>", $this->aFrontendErrors )."</p>";
    }

    $this->aFrontendErrors = array();
    
    return $sHTML;
  }
  
  public function item_chapters( $aItem , $iIndex, $aArgs ){

    if(!empty($aArgs['chapters'])){
      $aItem['chapters'] = apply_filters( 'fv_flowplayer_resource', $aArgs['chapters'] );
    }

    return  $aItem;
  }
  
  
  public function item_start_end( $aItem , $iIndex, $aArgs ){

    if(!empty($aArgs['startend'])){
      $aStartEnd = explode(';',$aArgs['startend']);
      if( !empty($aStartEnd[$iIndex]) ) {
        $aTimes = explode('-',$aStartEnd[$iIndex]);
        if( !empty($aTimes[0]) ) $aItem['fv_start'] = $aTimes[0];
        if( !empty($aTimes[1]) ) $aItem['fv_end'] = $aTimes[1];
      }
    }

    return  $aItem;
  }  
  
  
  function chapters_html( $html ) {

    $aArgs = func_get_args();
    
    if( !isset($aArgs[1]->aCurArgs['chapters']) || !strlen(trim($aArgs[1]->aCurArgs['chapters'])) ) {
      return $html;
    }

    if( $this->use_old_code() ){
      $this->aChapters[$aArgs[1]->hash] = array( trim($aArgs[1]->aCurArgs['chapters']) );
    }

    return $html."<ul class='fv_fp_chapters' id='fv_fp_chapters_".$aArgs[1]->hash."'></ul>";
  }  
  
  
  function transcript_sort_test($a,$b){
    return $this->hms_to_seconds($a['start']) > $this->hms_to_seconds($b['start']);
  }
  
  function transcript_html($html) {
      $aArgs = func_get_args();

      if (!isset($aArgs[1]->aCurArgs['transcript']) || !strlen(trim($aArgs[1]->aCurArgs['transcript']))) return $html;
      
      if ($aArgs[1]->aCurArgs['transcript'] === 'auto' && $this->is_vimeo($aArgs[1]->aCurArgs['src'])) {
        $transcriptUrl = 'https://vimeo.com' . $this->func__get_vimeo($aArgs[1]->aCurArgs['src'])->request->text_tracks[0]->url;
      }else{
        $transcriptUrl = apply_filters( 'fv_flowplayer_resource', $aArgs[1]->aCurArgs['transcript'] );
      }
      $error_message = '';
      if( !empty($transcriptUrl) && $transcriptUrl !== 'auto' ){
        $option_name = 'fv_player_pro_transcript_' . sanitize_title($transcriptUrl);
        $option = get_option($option_name, array('time' => 0, 'text' => ''));
        
        //  handle URL without domain
        $aURL = parse_url($transcriptUrl);
        if( !isset($aURL['host']) ) {
          $aHome = parse_url(home_url());
          $transcriptUrl = home_url($transcriptUrl);
          if( isset($aHome['path']) ) {
            $transcriptUrl = str_replace( $aHome['path'], '', $transcriptUrl );
          }
        }
        
        //first time or expired
        if (!isset($option['time']) || $option['time'] < (time())) {
          $response = wp_remote_get($transcriptUrl);
          if( !is_wp_error($response) ){
            //valid url, has data -> cache +1h
            $option = array('time' => time() + 900, 'text' => $response['body'] );   
          }else{
            //not a valid url ->cache + 1 min
            $option = array('time' => time() + 60, 'text' => "" );
            $error_message = $response->get_error_message();
          }
          update_option($option_name, $option);
        }
        $transcriptRaw = $option['text'];
        if(empty($transcriptRaw))return $html;
      }else{
        return $html;
      }
      

      $transcriptLines = explode("\n", $transcriptRaw);
      $trancsripData = array();
      $tId = 0;
      $time_last = 0;
      
      $time_last_break = 0;
      $bSentenceEnd = false;
      
      foreach ($transcriptLines as $line_no => $line) {
        $matches = array();
        
        //  hiding cue/chapter IDs
        if( preg_match('/^(Chapter )?\d+$/', trim($line) ) && preg_match('/^((?:[0-9]{2}:){1,2}[0-9]{2}[,.][0-9]{3}) --\> ((?:[0-9]{2}:){1,2}[0-9]{2}[,.][0-9]{3})(.*)/', $transcriptLines[$line_no+1], $matches)  ) {          
          continue;
        }
        
        if (preg_match('/^((?:[0-9]{2}:){1,2}[0-9]{2}[,.][0-9]{3}) --\> ((?:[0-9]{2}:){1,2}[0-9]{2}[,.][0-9]{3})(.*)/', $line, $matches)) {
          $time_now = $this->hms_to_seconds($matches[1]);
          
          $bShouldBreak = ( $time_now - $time_last > 5 ) ? true : false;  //  insert paragraph break if entries are more than 5 seconds apart
          if( $bShouldBreak ) {
            $time_last_break = $time_now;
          }
          
          if( $bSentenceEnd && $time_now - $time_last_break > 30 ) {  //  is sentenced has ended previously and it's 30 seconds since last break also insert paragraph break
            $bShouldBreak = true;
            $time_last_break = $time_now;
          }
          
          $trancsripData[$tId++] = array(
              'id' => $tId - 1,
              'start' => $matches[1],
              'end' => $matches[2],
              'text' =>  $time_last && $bShouldBreak ? '<br /><br />' : '',
          );
          $time_last = $time_now;

        } else {
          if (trim($line) && count($trancsripData)) {
            $trancsripData[$tId - 1]['text'].= ' '.$line."\n";
            $bSentenceEnd = strrpos(trim($line), '.') == strlen(trim($line)) - 1 ? true : false; // check if line ends a sentence
          }
        }
      }
      usort($trancsripData,array($this,'transcript_sort_test'));
      $transcriptHtml = "";
      foreach ($trancsripData as $key => $val) {
        $transcriptHtml .= '<span class="fv_fp_transcript_item" data-chapter="' . ($val['id']) . '">' . $val['text'] . ' </span>';
        unset($trancsripData[$key]['text']);
      }

      if(count($trancsripData)){
        //TODO: how to name js?
        wp_register_script('fvplayer-pro-mark-js', plugins_url('js/jquery.mark.min.js',__FILE__),array('jquery') );  
        wp_enqueue_script('fvplayer-pro-mark-js');
        
        return $html . '<div class="fv_fp_transcript_wrapper">'
                . '<label for="fv_fp_transcript_autoscroll' . $aArgs[1]->hash . '">Autoscroll:</label>&nbsp;<input class="fv_fp_transcript_autoscroll" id="fv_fp_transcript_autoscroll' . $aArgs[1]->hash . '" type="checkbox" checked />'
                . '<label for="fv_fp_transcript_search' . $aArgs[1]->hash . '">Search:</label>&nbsp;<input class="fv_fp_transcript_search" id="fv_fp_transcript_search' . $aArgs[1]->hash . '" type="text" />'
                . '<input type="button" class="search_result_prev" value="<" disabled><input type="button" class="search_result_next" value="&gt;" disabled>'
                . '<div class="fv_fp_transcript" id="fv_fp_transcript_' . $aArgs[1]->hash . '" data-player="#wpfp_'.$aArgs[1]->hash.'" data-transcript=\''.json_encode($trancsripData).'\'>' . $transcriptHtml . '</div></div>';
      }else{
        return $html . '<div class="fv_fp_transcript_wrapper">Error loading trascript. Please try again in a minute. ' . $error_message . '</div>';
      }
      
    }

  function convert__process( $type = 'YouTube' ) {
    echo '<p>Running the conversion process for '.$type.'. If anything fails, remember to restore your backup or revert the change of the post to the previous revision.</p>';
    echo '<p>Scroll down to the end of the list to see the status.</p>';
          
    $sType = sanitize_title($type);
          
    global $wpdb;
    $aPosts = $wpdb->get_results( "SELECT * FROM {$wpdb->posts} WHERE post_status != 'inherit' AND post_content LIKE '%".$sType."%' ORDER BY post_date DESC" );
      
    $tMax = ini_get('max_execution_time') ? ini_get('max_execution_time') : 30;
    $tStart = microtime(true);
    $iCount = 0;
    $iFound = 0;
    
    echo "<ul>\n";
    foreach( $aPosts AS $objPost ) {
      if( microtime(true) - $tStart > ($tMax - 2) ) {
        break;
      }
      
      $method = 'convert__'.$sType.'_callback';
      $new_content = $this->$method($objPost->post_content);
              
      if( strlen($new_content) != strlen($objPost->post_content) ) {
        $iFound++;
        
        $post_id = wp_update_post( array( 'ID' => $objPost->ID, 'post_content' => $new_content ) );
        if( is_wp_error($post_id) ) {
          $errors = $post_id->get_error_messages();
          echo "<li>".$objPost->ID." Error: ";
          foreach ($errors as $error) {
            echo $error;
          }
          echo "</li>";
        } else {
          $iCount++;
          echo "<li>".$objPost->ID.". <a target='_blank' href='".get_permalink($objPost->ID)."'>".$objPost->post_title."</a> updated ok</li>\n";
        }
      }
              
    }
    echo "</ul>\n";
    
    if( $iFound == 0 ) {
      echo "<p>No more posts with ".$type." embeds found!</p>\n";
    } else {
      echo "<p>Updated ".$iCount." posts out of ".$iFound." posts with ".$type." embeds.</p>\n";
    }
    
    if( microtime(true) - $tStart > ($tMax - 5) ) {
      echo "<p><strong>Execution terminated</strong>: PHP max_execution_time reached, run this process again to process the remaining posts!</p>\n";
    } else {
      echo "<p>All done!</p>\n";
    }
    
    die();
  }
  
  
  
  
  function convert__start() {
    if( current_user_can('manage_options') && isset($_GET['convert_youtube']) && wp_verify_nonce($_GET['convert_youtube'],'convert_youtube') ) {
      $this->convert__process('YouTube');
    }
    
    if( current_user_can('manage_options') && isset($_GET['convert_vimeo']) && wp_verify_nonce($_GET['convert_vimeo'],'convert_vimeo') ) {
      $this->convert__process('Vimeo');
    }
  }
  
  
  
  
  function convert__vimeo_callback( $content ) {
    $content = preg_replace( '~<iframe[^>]*?vimeo\.com/(?:video)/(\d+)[^>]*?></iframe>~', '[fvplayer src="https://vimeo.com/$1"]', $content );
    $content = preg_replace( '~<object.*?vimeo\.com/.*?clip_id=(\d+).*?</object>~', '[fvplayer src="http://vimeo.com/$1"]', $content );
    //var_dump($content);die(0);
    return $content;
  }
  
  

  
  function convert__youtube_callback( $content ) {
    $content = preg_replace( '~<iframe[^>]*?youtube(?:-nocookie)?\.com/(?:embed|v)/(.*?)[\'"&#\?][^>]*?></iframe>~', '[fvplayer src="http://youtube.com/watch?v=$1"]', $content );
    $content = preg_replace( '~<object.*?youtube(?:-nocookie)?\.com/(?:embed|v)/(.*?)[\'"&#].*?</object>~', '[fvplayer src="http://youtube.com/watch?v=$1"]', $content );
    //var_dump($content);die(0);
    return $content;
  }
  
  
  
  
  function disable_titles_vimeo_youtube( $aArgs ) {

    //  we don't want to avoid caption if it's set in lightbox anchor
    if( isset($aArgs['lightbox']) && $aArgs['lightbox'] ) {
      $aLightbox = preg_split('~[;]~', $aArgs['lightbox']);

      $bUseAnchor = false;
      foreach ($aLightbox AS $k => $i) {
        if ($i == 'text') {
          unset($aLightbox[$k]);
          $bUseAnchor = true;
        }
      }
      
      if( $bUseAnchor ) {
        return $aArgs;
      }
    }
    
    if( isset($aArgs['src']) && $this->is_vimeo($aArgs['src']) && $this->_get_option( array('pro','vimeo_titles_disable') )) {
      $aArgs['caption'] = '';
    } else if( isset($aArgs['src']) && $this->is_youtube($aArgs['src']) && $this->_get_option( array('pro','youtube_titles_disable') )) {
      $aArgs['caption'] = '';
    }
    return $aArgs;
  }
  
  
  
  
  function fv_player_admin_pro() {
    ?>
    <style>
      p.description { font-style: normal; }
    </style>
    <table class="form-table2" style="margin: 5px; ">
      <?php $this->_get_checkbox(__('Autoplay just once',            'fv-player-pro'), array('pro', 'autoplay_once'), __('Makes sure each video autoplays only once for each visitor.', 'fv-player-pro') ); ?>
      <?php $this->_get_checkbox(__('Custom start/end time',  'fv-player-pro'), array('pro', 'start_end'), __('Show only a smaller portion of your video.','fv-player-pro'),__('Not suitable as a content restriction, as the full video can be obtained by any skilled web developer and the feature doesn\'t work on iOS < 7 (use HLS and it will work on iOS 5 and 6) and Android < 4.', 'fv-player-pro') ); ?>
      <?php $this->_get_checkbox(__('Scroll autoplay',        'fv-player-pro'), array('pro', 'autoplay_scroll'), __('Automatically plays any video that comes into the browser viewport', 'fv-player-pro') ); ?>      
      <?php $this->_get_checkbox(__('AB Loop',                       'fv-player-pro'), array('pro', 'ab_loop'), __('Turn on AB Loop by default.', 'fv-player-pro') ); ?>
      <?php $this->_get_checkbox(__('Debug',                         'fv-player-pro'), array('pro', 'vimeo_debug'), __('Print debug messages to JS console.', 'fv-player-pro') ); ?>

      <tr>    		
        <td colspan="4">
          <input type="submit" name="fv-wp-flowplayer-submit" class="button-primary" value="<?php _e('Save All Changes', 'fv-player-pro'); ?>" style="margin-top: 2ex;"/>
        </td>
      </tr>         
    </table>
    <?php
  }
  
  
  
  
  function fv_player_admin_pro_cloudfront() {
    ?>
    <table class="form-table2" style="margin: 5px; ">
      <tr>
        <td colspan="2">
          <p>
            <?php _e('See Amazon Web Services Account -> Security Credentials -> CloudFront Key Pairs to get your key pair. We need the Access Key ID and the private key. See our <a href="http://foliovision.com/player/secure-amazon-s3-guide#cloudfront" target="_blank">CloudFront guide</a>.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <tr>
        <td style="vertical-align:top"><label for="pro[cf_domain]"><?php _e('CloudFront domain', 'fv-player-pro'); ?>:</label></td>
        <td>
          <input type="text" size="40" name="pro[cf_domain]" id="pro[cf_domain]" value="<?php  echo $this->_get_option( array('pro','cf_domain') ); ?>" />
          <p class="description"><?php _e('Enter {something}.cloudfront.net or your mapped domain. You can enter both, separated by <code>,</code>.', 'fv-player-pro'); ?></p>
        </td>
      </tr>        
      <tr>
        <td><label for="pro[cf_key_id]"><?php _e('Access Key ID', 'fv-player-pro'); ?>:</label></td>
        <td>
          <input type="text" size="40" name="pro[cf_key_id]" id="pro[cf_key_id]" value="<?php echo $this->_get_option( array('pro','cf_key_id') ); ?>" />
        </td>
      </tr>       
      <tr>
        <td style="width: 250px; vertical-align: top"><label for="pro[cf_pk]"><?php _e('Private Key', 'fv-player-pro'); ?>:</label></td>
        <td>
          <?php
          $bShowPK = true;
          if( $this->_get_option( array('pro','cf_pk') ) ) : $bShowPK = false; ?>
            <?php _e('Your Private Key file is present', 'fv-player-pro'); ?> <?php echo openssl_get_privatekey($this->_get_option( array('pro','cf_pk') )) ? __('and appears to be valid', 'fv-player-pro') : __('but <strong>invalid</strong> (Make sure it contains both "BEGIN RSA PRIVATE KEY" and "END RSA PRIVATE KEY")', 'fv-player-pro'); ?>. <a href="#" onclick="jQuery('#pro\\[cf_pk\\]').show(); return false"><?php _e('Click', 'fv-player-pro'); ?></a><?php _e(' to put in a new one', 'fv-player-pro'); ?>.
          <?php endif; ?>
          <textarea id="pro[cf_pk]" name="pro[cf_pk]" class="large-text code" placeholder="<?php _e('Enter your Private Key file here.', 'fv-player-pro'); ?>"<?php if( !$bShowPK ) echo ' style="display: none"'; ?>></textarea>
        </td>
      </tr>          
      <tr>    		
        <td colspan="4">
          <input type="submit" name="fv-wp-flowplayer-submit" class="button-primary" value="<?php _e('Save All Changes', 'fv-player-pro'); ?>" style="margin-top: 2ex;"/>
        </td>
      </tr>         
    </table>
    <?php
  }
  
  
  function fv_player_admin_pro_aws_decoder() {
    if(version_compare(phpversion(),'5.5.0','<')){
      ?>
      Your PHP version must be Newer than <b>5.5.0</b>   
        
      <?php
      return;
    }
    ?>
    <table class="form-table2" style="margin: 5px; ">
      <tr>
        <td colspan="2">
          <p>
<?php _e('You need to setup your key decoder to be able to use encrypted HLS streams on AWS. See our <a href="https://foliovision.com/player/video-hosting/securing-your-video/hls-stream" target="_blank">HLS guide</a>.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <tr>
        <td style="vertical-align:top"><label for="pro[elastic_key]"><?php _e('Access Key ID', 'fv-player-pro'); ?>:</label></td>
        <td>
          <input type="text" size="40" name="pro[elastic_key]" id="pro[elastic_key]" value="<?php echo $this->_get_option( array('pro','elastic_key') ); ?>" />
        </td>
      </tr>        
      <tr>
        <td><label for="pro[elastic_secret]"><?php _e('Access Key Secret', 'fv-player-pro'); ?>:</label></td>
        <td>
          <input type="text" size="40" name="pro[elastic_secret]" id="pro[elastic_secret]" value="<?php echo $this->_get_option( array('pro','elastic_secret') ); ?>" />
        </td>
      </tr>
      <tr>
        <?php $sRegion = $this->_get_option( array('pro','elastic_region') ); ?>
        <td><label for="pro[elastic_region]"><?php _e('Region', 'fv-player-pro'); ?>:</label></td>
        <td>
          <select id="pro[elastic_region]" name="pro[elastic_region]">
            <option value=""><?php _e('Select the region', 'fv-player-pro'); ?></option>
            <option value="eu-central-1"<?php if ($sRegion === 'eu-central-1') echo " selected"; ?>><?php _e('Frankfurt', 'fv-player-pro'); ?></option>
            <option value="eu-west-1"<?php if ($sRegion === 'eu-west-1') echo " selected"; ?>><?php _e('Ireland', 'fv-player-pro'); ?></option>
            <option value="us-west-1"<?php if ($sRegion === 'us-west-1') echo " selected"; ?>><?php _e('Northern California', 'fv-player-pro'); ?></option>
            <option value="us-west-2"<?php if ($sRegion === 'us-west-2') echo " selected"; ?>><?php _e('Oregon', 'fv-player-pro'); ?></option>
            <option value="sa-east-1"<?php if ($sRegion === 'sa-east-1') echo " selected"; ?>><?php _e('Sao Paulo', 'fv-player-pro'); ?></option>
            <option value="ap-southeast-1"<?php if ($sRegion === 'ap-southeast-1') echo " selected"; ?>><?php _e('Singapore', 'fv-player-pro'); ?></option>
            <option value="ap-southeast-2"<?php if ($sRegion === 'ap-southeast-2') echo " selected"; ?>><?php _e('Sydney', 'fv-player-pro'); ?></option>
            <option value="ap-northeast-1"<?php if ($sRegion === 'ap-northeast-1') echo " selected"; ?>><?php _e('Tokyo', 'fv-player-pro'); ?></option>
            <option value="us-east-1"<?php if ($sRegion === 'us-east-1') echo " selected"; ?>><?php _e('US Standard', 'fv-player-pro'); ?></option>
          </select>
        </td>

      </tr> 
      <tr>    		
        <td colspan="4">
          <input type="submit" name="fv-wp-flowplayer-submit" class="button-primary" value="<?php _e('Save All Changes', 'fv-player-pro'); ?>" style="margin-top: 2ex;"/>
        </td>
      </tr>         
    </table>
    <?php
  }
  
  
  function fv_player_admin_pro_quality() {
    ?>
    <style>
      .fv-player-pro_quality-remove { visibility: hidden; }
      td:hover > .fv-player-pro_quality-remove { visibility: visible; }
    </style>
    <table class="form-table2" style="margin: 5px; ">
      <tr>
        <td colspan="2">
          <p class="description">
            <?php _e('If you upload your videos in multiple qualities like <code>my-video-hd.mp4</code>, <code>my-video-sd.mp4</code>, <code>my-video-mobile.mp4</code>, then enter the <code>-hd</code>, <code>-sd</code> and <code>-mobile</code> filename parts into the fields below together with the labels. Then enable the quality switching for the video in the [fvplayer] shortcode. See <a href="https://foliovision.com/player/switch-video-quality" target="_new">How to set up quality switching</a>', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <tr>    		
        <td colspan="4">
          <table id="fv-player-pro_quality-settings">
            <thead>
              <tr>
                <td>
                  <?php _e('Naming scheme', 'fv-player-pro'); ?>
                </td>
                <td>
                  <?php _e('Label', 'fv-player-pro'); ?>
                </td>
                <td>

                </td>
              </tr>
            </thead>
            <tbody>
            <?php

            if( $aQualityItems = explode( "\n", $this->_get_option( array('pro', 'quality') ) ) ) {
              foreach( $aQualityItems AS $sQualityItem ) {
                $aQualityDetails = explode( ',', trim($sQualityItem) );
                $sName = isset($aQualityDetails[0]) ? trim($aQualityDetails[0]) : '';
                $sLabel = isset($aQualityDetails[1]) ? trim($aQualityDetails[1]) : '';
                echo "<tr class='data'><td><input type='text' name='aQualityItemNames[]' value='".esc_attr($sName)."' /></td><td><input type='text' name='aQualityItemLabel[]' value='".esc_attr($sLabel)."' /></td><td><a class='fv-player-pro_quality-remove' href=''>" . __('Remove', 'fv-player-pro') . "</a></td></tr>";
              }
            }
              
            ?>
            </tbody>
          </table>
        </td>
      </tr>         
      <tr>    		
        <td colspan="4">
          <input type="submit" name="fv-wp-flowplayer-submit" class="button-primary" value="<?php _e('Save All Changes', 'fv-player-pro'); ?>" />
          <input type="button" value="<?php _e('Add quality settings', 'fv-player-pro'); ?>" class="button" id="fv-player-pro_quality-add" />
        </td>
      </tr>         
    </table>
    <input name="fv_player_admin_pro_quality_alive" type="hidden" value="1" />
    <script>
    jQuery('#fv-player-pro_quality-add').click( function() {
      var new_inputs = jQuery('#fv-player-pro_quality-settings tr.data:first').clone(); 	
      new_inputs.find('input').attr('value','');  	
      //new_inputs.attr('class', new_inputs.attr('class') + '-' + fv_flowplayer_amazon_s3_count );
      new_inputs.insertAfter('#fv-player-pro_quality-settings tr:last');
      return false;
    } );
    
    jQuery(document).on('click','.fv-player-pro_quality-remove', false, function() {
      jQuery(this).parents('.data').remove();
      return false;
    } );
    
    jQuery(document).ready( function() {
      jQuery('#fv-player-pro_quality-settings tbody' ).sortable();
    } );
    </script>
    <?php
  }
  
  function fv_player_admin_pro_drm_text() {
    ?>
    <table class="form-table2" style="margin: 5px; ">
      <tr>
        <td colspan="2">
          <p class="description">
            <?php _e('Show user ID, IP and date over the video for short periods to allow you to track screen capture of your videos.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <?php $this->_get_checkbox(__('Global Enable', 'fv-player-pro'), array('pro', 'copy_text'), __('To enable for individual video, enable the option in <a href="#fv_flowplayer_interface_options">Post Interface Options</a> and then use shortcode editor.', 'fv-player-pro') ); ?>   
      <tr>
        <td><label for="copy_text_time"><?php _e('Interval', 'fv-wordpress-flowplayer'); ?>:</label></td>
        <td colspan="3">
          <p class="description">
            <?php $value = $this->_get_option( array('pro','copy_text_time') ); ?>
            <select id="copy_text_time" name="pro[copy_text_time]">
              <option value="5"   <?php if( $value == 5 ) echo ' selected="selected"'; ?> >5 seconds</option>
              <option value="20"  <?php if( $value == 20 ) echo ' selected="selected"'; ?> >20 seconds</option>
            </select>            
          </p>
        </td>
      </tr>      
      <tr>    		
        <td colspan="4">
          <input type="submit" name="fv-wp-flowplayer-submit" class="button-primary" value="<?php _e('Save All Changes', 'fv-player-pro'); ?>" />          
        </td>
      </tr>         
    </table>
    <?php
  }  
  
  function fv_player_admin_pro_video_ads_description(){
   ?>
    <table class="form-table">
      <tr>
        <td colspan="4">
          <p>
            <?php _e('This feature lets You configure multiple, clickable Video Ads, that can be played before or after Your videos.', 'fv-player-pro'); ?>
          </p>
          <p>
            <?php _e('You can configure video ads globally, or on a per video basis.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
    </table>
<?php 
  }
  
  function fv_player_admin_pro_video_ads() {
    global $fv_fp;
    ?>
    <style>
      #fv-player-pro_video-ads-settings tr.data:nth-child(even) { background-color: #eee; }
      .fv-player-pro_video-ad-remove { visibility: hidden; }
      td:hover > .fv-player-pro_video-ad-remove { visibility: visible; }
      table.fv-player-pro_video-ad-formats td:first-child { width: 132px }
      .meta-box-sortables input.smaller { width: 64px }
    </style>
    <table class="form-table2" style="margin: 5px; ">
      <tr>
        <td style="width: 250px"><label for="pro[video_ads_default]"><?php _e('Default pre-roll ad', 'fv-player-pro'); ?>:</label></td>
        <td>
          <p class="description">
            <?php $cva_id = $this->_get_option( array('pro','video_ads_default') ); ?>
            <?php $this->admin__select_video_ads( array('cva_id'=>$cva_id,'id'=>'pro[video_ads_default]') ); ?>
            <?php _e('Set which ad should be played before videos.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <tr>
        <td style="width: 250px"><label for="pro[video_ads_postroll_default]"><?php _e('Default post-roll ad', 'fv-player-pro'); ?>:</label></td>
        <td>
          <p class="description">
            <?php $cva_id = $this->_get_option( array('pro','video_ads_postroll_default') ); ?>
            <?php $this->admin__select_video_ads( array('cva_id'=>$cva_id,'id'=>'pro[video_ads_postroll_default]')); ?>
            <?php _e('Set which ad should be played after videos.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <tr>
        <td style="width: 250px"><label for="pro[video_ads_skip]"><?php _e('Default ad skip time', 'fv-player-pro'); ?>:</label></td>
        <td>
          <p class="description">
            <input class="smaller" id="pro[video_ads_skip]" name="pro[video_ads_skip]" title="<?php _e('Enter value in seconds', 'fv-player-pro'); ?>" type="text" value="<?php echo $this->_get_option( array('pro','video_ads_skip') )?>" />
            <?php _e('Enter the number of seconds after which an ad can be skipped if longer than ', 'fv-player-pro'); ?>
            <input class="smaller" id="pro[video_ads_skip_minimum]" name="pro[video_ads_skip_minimum]" title="<?php _e('Enter value in seconds', 'fv-player-pro'); ?>" type="text" value="<?php echo $this->_get_option( array('pro','video_ads_skip_minimum') )?>" />
            <?php _e(' seconds.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      
      <?php $this->_get_checkbox(__('Limit ad playback', 'fv-player-pro'), array('pro', 'video_ads_once'), __('Each browser will get each ad only once per day.', 'fv-player-pro') ); ?>
      
      </table>
      <table class="form-table2" style="margin: 5px; ">  
      <tr>    		
        <td>
          <table id="fv-player-pro_video-ads-settings">
            <thead><tr><td><?php _e('ID', 'fv-player-pro'); ?></td><td></td><td><?php _e('Status', 'fv-player-pro'); ?></td></tr></thead>
            <tbody>
            <?php
            if( !isset($fv_fp->conf['pro']['video_ads']) || !is_array($fv_fp->conf['pro']['video_ads']) || count($fv_fp->conf['pro']['video_ads']) == 0 ) {
              $fv_fp->conf['pro']['video_ads'] = array( array(
                                                'videos' => array(
                                                     'mp4' => '',
                                                     'webm' => '',
                                                     'ogv' => '',
                                                     'hls' => '',
                                                     'flash' => '',
                                                     'rtmp' => '',
                                                   ),
                                                'name' => '',
                                                'disabled' => false,
                                                'click' => false
                                                ) );              
            }
            
            
            $i = 0;
            foreach( $this->_get_option( array('pro','video_ads') ) AS $key => $aVideoAd ) {
              
              echo "\t<tr class='data'>\n";
              echo "\t\t<td class='id'>".($key+1)."</td>\n";
              echo "";
              echo "\t\t<td>\n";
              echo "\t\t\t<table class='fv-player-pro_video-ad-formats'>\n";
              echo "\t\t\t\t<tr><td><label>" . __('Name', 'fv-player-pro') . ":</label></td><td colspan='2'><input type='text' name='aVideoAd_name[".$i."]' value='".( !empty($aVideoAd['name']) ? esc_attr($aVideoAd['name']) : '' )."' placeholder='" . __('Ad name', 'fv-player-pro') . "' /></td></tr>\n";
              echo "\t\t\t\t<tr><td><label>" . __('Click URL', 'fv-player-pro') . ":</label></td><td colspan='2'><input type='text' name='aVideoAdClick[".$i."]' value='".esc_attr($aVideoAd['click'])."' placeholder='" . __('Clicking the video ad will open the URL in new window', 'fv-player-pro') . "' /></td></tr>\n";
              echo "\t\t\t\t<tr><td><label>" . __('Video', 'fv-player-pro') . ":</label></td><td colspan='2'><input type='text' name='aVideoAd_mp4[".$i."]' value='".esc_attr($aVideoAd['videos']['mp4'])."' placeholder='" . __('Enter the video URL here', 'fv-player-pro') . "' /></td></tr>\n";
              echo "\t\t\t</table>\n";
              echo "\t\t</td>\n";
              echo "\t\t<td>\n";
              echo "\t\t\t<input type='hidden' name='aVideoAdDisabled[".$i."]' value='0' /><input id='VideoAdDisabled-".$i."' type='checkbox' name='aVideoAdDisabled[".$i."]' value='1' ".($aVideoAd['disabled'] ? 'checked="checked"' : '')." /> <label for='VideoAdDisabled-".$i."'>" . __('Disable', 'fv-player-pro') . "</label><br />\n";
              echo "\t\t\t<a class='fv-player-pro_video-ad-remove' href=''>" . __('Remove', 'fv-player-pro') . "</a></td>\n";
              echo "\t</tr>\n";
              
              $i++;
            }
              
            ?>
            <script>var fv_player_pro_cva_count = <?php echo ++$i; ?>;</script>
            </tbody>
          </table>
        </td>
      </tr>         
      <tr>    		
        <td>
          <input type="submit" name="fv-wp-flowplayer-submit" class="button-primary" value="<?php _e('Save All Changes', 'fv-player-pro'); ?>" />
          <input type="button" value="<?php _e('Add more video ads', 'fv-player-pro'); ?>" class="button" id="fv-player-pro_video-ads-add" />
        </td>
      </tr>         
    </table>
    <input name="fv_player_admin_pro_video_ads_alive" type="hidden" value="1" />
    <script>
    var fv_player_pro_video_ads_count = '<?php echo $i; ?>';
    jQuery('#fv-player-pro_video-ads-add').click( function() {
      var new_inputs = jQuery('#fv-player-pro_video-ads-settings tr.data:first').clone(); 	
      new_inputs.find('input[type=text]').attr('value','');
      new_inputs.find('td.id').html( fv_player_pro_cva_count );
      fv_player_pro_cva_count++;
      new_inputs.find('input[name]').each( function() {
        jQuery(this).attr( 'name', jQuery(this).attr('name').replace(/\[\d]$/, '['+fv_player_pro_video_ads_count+']' ) );
      });      
      new_inputs.find('input[id]').each( function() {
        jQuery(this).attr( 'id', jQuery(this).attr('id').replace(/-\d$/, '-'+fv_player_pro_video_ads_count ) );
      });
      new_inputs.find('label[for]').each( function() {
        jQuery(this).attr( 'for', jQuery(this).attr('for').replace(/-\d$/, '-'+fv_player_pro_video_ads_count ) );
      });
      
      new_inputs.find('.fv-player-pro_extra-format').hide();
      new_inputs.insertAfter('#fv-player-pro_video-ads-settings tr.data:last');
      fv_player_pro_video_ads_count++;
      return false;
    } );
    
    jQuery(document).on('click','.fv-player-pro_video-ad-remove', false, function() {
      if( confirm('<?php _e('Are you sure you want to remove the video ad?', 'fv-player-pro'); ?>') )
      {
        jQuery(this).parents('.data').remove();
      }      
      return false;
    } );
    
    jQuery(document).ready( function() {
      jQuery('#fv-player-pro_quality-settings tbody' ).sortable();
    } );
    </script>
    <?php
  }    
  
  
  
  
  function fv_player_admin_pro_vimeo() {
    ?>
    <table class="form-table2" style="margin: 5px; ">
      <?php $this->_get_checkbox(__('Advanced Vimeo embedding', 'fv-player-pro'), array('pro', 'vimeo'), __('Use Vimeo as your video host and use all of FV Flowplayer features.', 'fv-player-pro') ); ?>

<?php if( $this->_get_option( array('pro','vimeo') ) ): ?>
      <tr>
        <td style="width: 250px"></td>
        <td>          
            <p>
<?php
            global $wpdb;
            if( $this->_get_option( array('pro','vimeo_direct_ajax') ) ) {
              $cache_items = count(scandir(WP_CONTENT_DIR . '/cache/fv-player-vimeo'));
            } else {
              $cache_items = $wpdb->get_var("SELECT count(*) FROM $wpdb->options WHERE option_name LIKE 'fv_player_pro_vimeo_%' ");
            }
            _e('Currently ', 'fv-player-pro');
            echo $cache_items.( ( $cache_items == 1 ) ? __(' Vimeo video is cached.', 'fv-player-pro') : __(' Vimeo videos are cached.', 'fv-player-pro') ); ?></p>
            <?php if( isset($_GET['vimeo_debug']) ) {
              echo "Servers: ";
              print_r( get_option('fv_player_pro_api') );
            } ?>
        </td>
      </tr>
      <tr>
        <td colspan="2">
          <p>
<?php _e('Vimeo <strong>Plus</strong> or <strong>Pro</strong> account is required. Due to Vimeo terms of use we require that we check your account before serving videos via FV Player. Simply <a href="https://developer.vimeo.com/apps/new">create a new Vimeo App</a> (use your site name, site description and site URL) and then copy "Access token" from the "oAuth2" tab.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <tr>
        <td><label for="pro[vimeo_at]"><?php _e('Access token', 'fv-player-pro'); ?>:</label></td>
        <td>
          <?php if( defined('FV_PLAYER_VIMEO_KEY') ) : ?>
            <input type="text" size="40" value="<?php _e('Defined as FV_PLAYER_VIMEO_KEY in your wp-config.php: ', 'fv-player-pro'); ?><?php echo FV_PLAYER_VIMEO_KEY; ?>" disabled="true" />
          <?php else : ?>
            <input type="text" size="40" name="pro[vimeo_at]" id="pro[vimeo_at]" value="<?php echo $this->_get_option( array('pro','vimeo_at') ); ?>" />
          <?php endif; ?>                       
          <?php
          if( $this->get__vimeo_key() ) {
            $result = $this->vimeo_key_check_cache();
            if( !empty($result['error']) ) : ?>
              <p><?php _e('Your Vimeo access token appears to be <strong>invalid</strong>', 'fv-player-pro'); ?>: '<?php echo $result['error']; ?>' (<?php _e('last check', 'fv-player-pro'); ?>: <?php echo date('r', $result['time']); ?>)</p>
            <?php else : ?>
              <p><?php _e('Your Vimeo access token has been successfully verified (last check', 'fv-player-pro'); ?>: <?php echo date('r',$result['time']); ?>)</p>
            <?php endif;
          } ?>
        </td>
      </tr>
  <?php $this->_get_checkbox(__('Enable quality switching', 'fv-player-pro'), array('pro', 'vimeo_qs'), __('Without this option the HD video will be used all the time, with exception of iPhone and Android which get mobile quality.', 'fv-player-pro') ); ?>
  <?php $this->_get_checkbox(__('Disable video captions',     'fv-player-pro'), array('pro', 'vimeo_titles_disable'), __('Normally the video title is parsed into the shortcode when saving the post, with this setting it won\'t appear.', 'fv-player-pro') ); ?>


  <?php
  global $fv_wp_flowplayer_ver;
  if( version_compare($fv_wp_flowplayer_ver,'6.0.5.8') == 1 ){
    $this->_get_checkbox(__('Disable MPEG-DASH',      'fv-player-pro'), array('pro', 'vimeo_dash_disable'), __('Check if you are experiencing issues with Vimeo playback and report to Foliovision support forums.', 'fv-player-pro') );
  }
  ?>

  <?php $this->_get_checkbox(__('Force <code>iframe</code> Embedding',  'fv-player-pro'), array('pro', 'vimeo_iframe'), __('If you experience issues with our Vimeo integration you can enable this option temporarily to fix playback of at least single videos. Playlists and lightbox are not supported.', 'fv-player-pro') ); ?>

      <tr>
        <?php $sRegion = $this->_get_option( array('pro','vimeo_location') ); ?>
        <td><label for="pro[vimeo_location]"><?php _e('Preferred API location', 'fv-player-pro'); ?>:</label></td>
        <td>
          <p class="description">
            <select id="pro[vimeo_location]" name="pro[vimeo_location]">
              <option value=""><?php _e('Pick fastest automatically', 'fv-player-pro'); ?></option>
              <option value="api"<?php if ($sRegion === 'api') echo " selected"; ?>><?php _e('North America', 'fv-player-pro'); ?></option>
              <option value="api-eu"<?php if ($sRegion === 'api-eu') echo " selected"; ?>><?php _e('Europe', 'fv-player-pro'); ?></option>
              <option value="api-sg"<?php if ($sRegion === 'api-sg') echo " selected"; ?>><?php _e('Asia', 'fv-player-pro'); ?></option>
            </select>
            <?php _e('If most of your visitors come from Asia, we recommend using that location.', 'fv-player-pro'); ?>
          </p>
        </td>

      </tr>

      <tr>
        <td style="width: 250px; vertical-align: top; padding-top: 5px"><label for="pro[vimeo_direct_ajax]"><?php _e('Turbocharge Ajax Vimeo loading', 'fv-player-pro'); ?> (Beta):</label></td>
        <td>
          <p class="description">
            <input type="hidden" value="false" name="pro[vimeo_direct_ajax]" />
            <input type="checkbox" value="true" name="pro[vimeo_direct_ajax]" id="pro[vimeo_direct_ajax]" 
              <?php if( defined('FV_PLAYER_VIMEO_KEY') && $this->_get_option( array('pro','vimeo_direct_ajax') ) ) echo 'checked="checked"'; ?>
              <?php if( !defined('FV_PLAYER_VIMEO_KEY') ) echo 'disabled="disabled"'; ?> />
            <?php _e('Vimeo requests will be handled by a simple PHP file rather than loading entire WordPress.', 'fv-player-pro'); ?>
            <?php if( !defined('FV_PLAYER_VIMEO_KEY') && $this->get__vimeo_key() ) : ?>
              <?php _e('To use this feature you have to put the following into your wp-config.php file:', 'fv-player-pro'); ?>
              </p>
              <p>
                <code>define('FV_PLAYER_VIMEO_KEY','<?php echo $this->get__vimeo_key(); ?>');</code>
                <?php echo defined('FV_PLAYER_VIMEO_KEY') ? 'Found!' : '<strong>Missing!</strong>'; ?>
            <?php if( $sRegion ) : ?>
                  <br /><code>define('FV_PLAYER_VIMEO_LOCATION','<?php echo $sRegion; ?>');</code>
                  <?php echo defined('FV_PLAYER_VIMEO_LOCATION') ? 'Found!' : '<strong>Missing!</strong>'; ?>
                <?php endif; ?>

            <?php endif; ?>
          </p>
        </td>
      </tr>
<?php endif; ?>      
      <tr>    		
        <td colspan="4">
          <input type="submit" name="fv-wp-flowplayer-submit" class="button-primary" value="<?php _e('Save All Changes', 'fv-player-pro'); ?>" style="margin-top: 2ex;"/>
          <input type="button" class="button" value="<?php _e('Convert Vimeo embed codes', 'fv-player-pro'); ?>" style="margin-top: 2ex;" onclick="if( confirm('<?php _e('This converts the IFRAME and OBJECT Vimeo embeds into [fvplayer] shortcodes.\n\n Please make sure you backup your database before continuing.', 'fv-player-pro'); ?>') ) location.href='<?php echo wp_nonce_url( site_url('wp-admin/options-general.php?page=fvplayer'), 'convert_vimeo', 'convert_vimeo'); ?>'; "/>
        </td>
      </tr>         
    </table>
    <?php
  }
  
  
  
  
  function fv_player_admin_pro_youtube() {
    ?>
    <table class="form-table2" style="margin: 5px; ">
      <tr>
        <td colspan="2">
          <p class="description">
            <?php _e('We use the Chromeless API so general <a href="#fv_flowplayer_skin">FV Player settings</a> apply here.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <tr>
        <td style="width: 250px"><label for="pro[yt_logo]"><?php _e('Remove logo (beta)', 'fv-player-pro'); ?>:</label></td>
        <td>
          <p class="description">
            <input type="hidden" value="false" name="pro[yt_logo]" />
            <input type="checkbox" value="true" name="pro[yt_logo]" id="pro[yt_logo]" <?php if( $this->_get_option( array('pro','yt_logo') )) echo 'checked="checked"'; else echo 'onclick="return confirm(\'I am aware that Google may consider obscuring YouTube branding as a violation of YouTube terms of service and result in Google closing your YouTube or Adwords accounts.\');"'; ?> />
          </p>
        </td>
      </tr>
      <?php $this->_get_checkbox(__('Enable quality switching', 'fv-player-pro'), array('pro', 'youtube_qs'), __('Allows you to switch the video quality manually, otherwise you get the best quality based on your device, connection speed and player size.', 'fv-player-pro' ), __('However YouTube API responds to manual quality switching very slowly.', 'fv-player-pro') ); ?>
      <?php $this->_get_checkbox(__('Disable video captions', 'fv-player-pro'), array('pro', 'youtube_titles_disable'), __('Normally the video title is parsed into the shortcode when saving the post, with this setting it won\'t appear.', 'fv-player-pro') ); ?>
      <?php $this->_get_checkbox(__("Disable YouTube <a href='#'>Video Ads</a> on mobile", 'fv-player-pro'), array('pro', 'youtube_ads_disable'), __("Using FV Player Pro Video Ads for YouTube only works for iOS >= 10 and Android >= 6.", 'fv-player-pro'), __("Use this checkbox to disable it completely for all mobile phones if you get any complaints.", 'fv-player-pro') ); ?>
      
      <script>
        jQuery('[for=pro\\[youtube_ads_disable\\]] a').click( function(e) {
          e.preventDefault();
          e.stopPropagation();
          
          jQuery('[href=#postbox-container-tab_video_ads]').click();
        });
      </script>
      
      <tr>
        <td style="width: 250px"><label for="pro[youtube_key]"><?php _e('Google Developer Key', 'fv-player-pro'); ?>:</label></td>
        <td>
          <p class="description">
            <input type="text" name="pro[youtube_key]" id="pro[youtube_key]" value="<?php  echo $this->_get_option( array('pro','youtube_key') ); ?>" />
            <?php _e('Required for a reliable YouTube splash screen and YouTube video duration parsing. Start a new project at <a href="https://console.developers.google.com/" target="_blank">Google Developers Console</a> and make sure YouTube Data API is enabled for the project.', 'fv-player-pro'); ?>
          </p>
        </td>
      </tr>
      <?php if( $sError = get_option('fv_player_pro_youtube_error') ) : ?>
        <tr>
          <td style="width: 250px"></td>
          <td>
            <p class="description">
              <?php _e('Last Error', 'fv-player-pro'); ?>: <?php echo $sError; ?>
            </p>
          </td>
        </tr>
      <?php endif; ?>
      <tr>    		
        <td colspan="4">
          <input type="submit" name="fv-wp-flowplayer-submit" class="button-primary" value="<?php _e('Save All Changes', 'fv-player-pro'); ?>" style="margin-top: 2ex;"/>
          <input type="button" class="button" value="<?php _e('Convert YouTube embed codes', 'fv-player-pro'); ?>" style="margin-top: 2ex;" onclick="if( confirm('<?php _e('This converts the IFRAME and OBJECT YouTube embeds into [fvplayer] shortcodes.\n\n Please make sure you backup your database before continuing.', 'fv-player-pro'); ?>') ) location.href='<?php echo wp_nonce_url( site_url('wp-admin/options-general.php?page=fvplayer'), 'convert_youtube', 'convert_youtube'); ?>'; "/>
        </td>
      </tr>         
    </table>
    <?php
  }    
  

  
  function func__get_qualities() {

    $quality = $this->_get_option( array('pro','quality') );

    if( strlen(trim($quality)) == 0 ) {
      return false;
    }
    
    $aOutput = false;
    $aQualities = explode( "\n", $quality );
    $aQualities = array_map('trim', $aQualities);
    foreach( $aQualities AS $key => $item ) {
      $aItem = explode( ',', trim($item) );
      $aItem = array_map('trim', $aItem);
      if( strlen($aItem[0]) && is_array($aItem) && count($aItem) >= 2 ) {
        $aOutput[$aItem[0]] = $aItem[1];
      }
    }

    return $aOutput;
  }
  
  
  
  
  function func__get_video_ads() {

    $aVideoAdds = $this->_get_option( array('pro','video_ads') );

    if( count($aVideoAdds) === 0 ) {
      return false;
    }
    
    $bFound = false;
    foreach( $aVideoAdds AS $k => $i ) {
      if( isset($i['videos']) ) {
        foreach( $i['videos'] AS $l => $m ) {
          if( strlen(trim($m)) ) {
            $bFound = true;
          }
        }
      }
    }
    
    if( $bFound ) {
      return $aVideoAdds;
    } else {
      return false;
    }
  }  
  
  
  

  function func__get_vimeo( $video_url ) {
    global $fv_wp_flowplayer_ver;

    if( !class_exists('flowplayer') || !flowplayer::is_licensed() ) {
      return json_decode(json_encode(array( 'error' => 'FV Flowplayer license not found!' )), FALSE);
    }
        
    if( !$video_id = $this->func__get_vimeo_id($video_url) ) {
      return json_decode(json_encode(array( 'error' => 'Bad video ID!' )), FALSE);
    }        
    
    $bFound = false;
    $objVideo = get_option( $this->get__transient_name('vimeo').$video_id );    
    if( $objVideo && isset($objVideo->time) && isset($objVideo->ttl) && (intval($objVideo->time) + intval($objVideo->ttl)) > time() ) {
      $objVideo->cache = true;
      $objVideo->time_now = time();
      $bFound = true;
      if( isset($objVideo->id) ) $this->func__http( array( 'action' => 'v_ping', 'item_id' => intval($objVideo->id), 'async' => true ) );
    }
    
    if( !$bFound ) {
      $sResponse = $this->func__http( array( 'action' => !$this->_get_option( array('pro','vimeo_dash_disable') ) && version_compare($fv_wp_flowplayer_ver,'6.0.5.8') == 1 ? 'v_grab_dash' : 'v_grab', 'item_id' => intval($video_id) ) );
      if( stripos($sResponse,'privacy settings') !== false ) {
        $objVideo = new stdClass;
        $objVideo->error = 'Video can\'t be played because of its privacy settings. Please allow you site domain to embed the video in its settings.';
        $iTTL = 30;
      } else {
        $aResponse = explode( '<FVSERVICES>', $sResponse );
        $objVideo = false;
        if( isset($aResponse[1]) ) {
          $aResponse = explode( '</FVSERVICES>', $aResponse[1] );
          $objVideo = json_decode($aResponse[0]);
          $iTTL = 120;
        }
        
        if( !$objVideo ) {
          $objVideo = new stdClass;
          $objVideo->error = $sResponse ? $sResponse : 'Parse error.';
          $iTTL = 30;
        }
                
      }
      $objVideo->time = ( isset($objVideo->time) && intval($objVideo->time) > 0 ) ? $objVideo->time : time();
      $objVideo->ttl = ( isset($objVideo->ttl) && intval($objVideo->ttl) > 0 ) ? $objVideo->ttl : $iTTL;
			if( $objVideo->ttl > 1200 ) $objVideo->ttl  = 1200;

    }
    
    $time = $objVideo->time;
    $blog_id = get_current_blog_id();
    $sDashFolder = WP_CONTENT_DIR . '/cache/fv-player-mpd/'.$blog_id . '/';
    $sDashFile = 'manifest-'.$video_id.'-'.$time.'.mpd';
    $sDashPath = $sDashFolder . $sDashFile;

    if( !$bFound || !file_exists($sDashPath) ) {
      if( isset($objVideo->mpd) && $objVideo->mpd && isset($objVideo->mpd->xml) && isset($objVideo->mpd->init_segments) && !$this->_get_option( array('pro','vimeo_dash_disable') ) && version_compare($fv_wp_flowplayer_ver,'6.0.5.8') == 1  ){
        
        if( !file_exists($sDashFolder) ) {
          mkdir($sDashFolder,0755,true);
        }
        
        if( !file_exists($sDashFolder.'index.php') ) {
          file_put_contents( $sDashFolder.'index.php', '<'.'?php /'.'* Nothing *'.'/ ?'.'>' );
        }  
        
        $this->vimeo_mpd_htaccess();
        
        $base_url = trailingslashit( str_replace( array('/plugins','\\plugins'), '', str_replace( array('http://','https://'),'//', plugins_url()) ) ) . 'cache/fv-player-mpd/'.$blog_id . '/';
        
        //file_put_contents( ABSPATH.'mpd.log', date('r').":\n".var_export($objVideo->mpd,true)."\n\n", FILE_APPEND );
        
        $objVideo->mpd->xml = str_replace(array('%mpd_url%','%mpd_time%'),array($base_url,$time),$objVideo->mpd->xml);
        $objVideo->request->files->dash->url = $base_url.$sDashFile;
        file_put_contents( $sDashPath, $objVideo->mpd->xml );     
        unset($objVideo->mpd->xml);
        
        foreach($objVideo->mpd->init_segments as $key => $segment){        
          file_put_contents( $sDashFolder . 'init-'.$video_id.'-'.$time.'-'.$key.'.mp4', base64_decode($segment));
          unset($objVideo->mpd->xml);
        }

        if(isset($objVideo->mpd->audio_segments)){
          foreach($objVideo->mpd->audio_segments as $key => $segment){
            file_put_contents( $sDashFolder . 'init-'.$video_id.'-'.$time.'-'.$key.'.m4s', base64_decode($segment));
            unset($objVideo->mpd->xml);
          }
        }

      } else if (is_object($objVideo) && isset($objVideo->request) && is_object($objVideo->request) && isset($objVideo->request->files) && is_object($objVideo->request->files) ) {
        unset($objVideo->request->files->dash);
        
      }
      
      if( isset($objVideo->mpd_backup) && $objVideo->mpd_backup && isset($objVideo->mpd_backup->xml) && isset($objVideo->mpd_backup->init_segments) && !$this->_get_option( array('pro','vimeo_dash_disable') ) && version_compare($fv_wp_flowplayer_ver,'6.0.5.8') == 1 ){
        
        if( !file_exists($sDashFolder) ) {
          mkdir($sDashFolder,0755,true);
        }
        
        $sDashFile = 'manifest-'.$video_id.'-backup-'.$time.'.mpd';
        $sDashPath = $sDashFolder . $sDashFile;
        
        $base_url = trailingslashit( str_replace( array('/plugins','\\plugins'), '', str_replace( array('http://','https://'),'//', plugins_url()) ) ) . 'cache/fv-player-mpd/'.$blog_id . '/';
        
        //file_put_contents( ABSPATH.'mpd.log', date('r').":\n".var_export($objVideo->mpd_backup,true)."\n\n", FILE_APPEND );
        
        $objVideo->mpd_backup->xml = str_replace(array('%mpd_url%','%mpd_time%'),array($base_url,$time),$objVideo->mpd_backup->xml);
        $objVideo->request->files->dash->url_backup = $base_url.$sDashFile;
        file_put_contents( $sDashPath, $objVideo->mpd_backup->xml );     
        //unset($objVideo->mpd_backup->xml);
        
      }
    }
   
    if( !$bFound ) {
      update_option( $this->get__transient_name('vimeo').$video_id, $objVideo, false );

    }
    
    return $objVideo;
  }
  
  
  
  
  function func__get_vimeo_id( $video_url ) {
    if( preg_match( "~vimeo.com/(?:video/|moogaloop\.swf\?clip_id=)?(\d+)~i", $video_url, $video_id ) ) {
      return $video_id[1];
    } else {
      return false;
    }
  }
  
  
  
  
  function func__http( $aArgs ) {

    $aPOST = array_merge( $aArgs,
                  array(
                  'version' => $this->version,
                  'site' => home_url(),
                  'key' => $this->_get_option('key'),
                  'vimeo_at' => $this->get__vimeo_key()
                  )
                );
  
    $sPOST = '';
    foreach( $aPOST as $key=>$value) {
      $sPOST .= $key.'='.$value.'&';
    }
    rtrim( $sPOST, '&' );
    
    
    //  first we check the stored scores for each API
    $aServers = array( 'api' => 0, 'api-eu' => 0, 'api-sg' => 0 );
    $aServersCache = get_option( 'fv_player_pro_api', array() );
    
    // admin setting for server selected by default
    $defaultServer = $this->_get_option(array('pro','vimeo_location'));

    // if there is no _time key in servers list, add it there,
    // since this is our first clean run without any cache
    if (!isset($aServersCache['_time'])) {
      $aServersCache['_time'] = time();
    }

    // only check once every 24 hours or 1 hour if we have a preferred server
    $cacheClearTime = $aServersCache['_time'] + 24 * 3600;
    if ($defaultServer) {
      $cacheClearTime = $aServersCache['_time'] + 900;
    }

    if( isset($aServersCache['_time']) && $cacheClearTime < time() ) {
      $aServersCache = array();
    }
    
    $aServers = array_merge( $aServers, $aServersCache );
    $bTest = in_array(0,$aServers) ? true : false;
    $noPredefinedServer = ($defaultServer ? false : true);

    $iServersAvailable = 0;
    
    $iMin = 9999;

    // if the default server is not set, set it to API
    if (!$defaultServer) {
      $defaultServer = 'api';
    }

    $sWinner = $defaultServer;
    $defaultServerAvailable = false;
    foreach( $aServers AS $sAPI => $sScore ) {
      if( $sAPI == '_time' ) continue;
      
      if( $iMin > $sScore ) {
        $sWinner = $sAPI;
        $iMin = $sScore;
      }
      
      if( $sScore < 9999 ) {
        $iServersAvailable++; //  we need to know how many servers are left for retry

        // if default server is usable, use it
        if ($sAPI === $defaultServer && !$noPredefinedServer) {
          $defaultServerAvailable = true;
        }
      }
    }

    if ($defaultServerAvailable && $sWinner !== $defaultServer) {
      $sWinner = $defaultServer;
    }
    //

    if( isset($aArgs['async']) ) {
      $pSocket = @fsockopen( $sWinner.".foliovision.com", 443, $errno, $errstr, 10 );
      if( $pSocket ) {
        $strOut =  "POST / HTTP/1.1\r\n";
        $strOut .= "Host: ".$sWinner.".foliovision.com\r\n";
        $strOut .= "Content-Type: application/x-www-form-urlencoded\r\n";
        $strOut .= "Content-Length: ".strlen( $sPOST )."\r\n";
        $strOut .= "Connection: Close\r\n\r\n";
        $strOut .= $sPOST;
        
        fwrite( $pSocket, $strOut );
        fclose( $pSocket );
      }
      return null;
      
    } else {
      $tStart = microtime(true);
      $response = wp_remote_post( "https://".$sWinner.".foliovision.com/", array(
          'body' => $aPOST,
          'user-agent' => $_SERVER['HTTP_USER_AGENT'],
          'sslverify' => false,
          'timeout' => 15
        ) );
      
      //  store what you measured, but only if it's testing phase or there was an error!
      $tDuration = is_wp_error( $response ) ? 9999 : ceil( ( microtime(true) - $tStart ) * 1000 );
      
      //file_put_contents( ABSPATH.'fv-api.log', date('r').": ".$sWinner." (".$tDuration.") ".$bTest."\n", FILE_APPEND );
      
      $aServers[$sWinner] = $tDuration;
      $aServers['_time'] = time();
      if( $bTest || is_wp_error( $response ) ) {
        update_option( 'fv_player_pro_api', $aServers );
      }
      //
      
      if( is_wp_error( $response ) ) {
        $this->iLoadingRecursion++;
        if( $this->iLoadingRecursion > $iServersAvailable ) {
          update_option( 'fv_player_pro_api', array() );
          return '';  //  it will already say "Please reload the page and try again in a couple of minutes."        
        } else {
          return $this->func__http($aArgs);
        }

      } else {  
        return $response['body'];
      }
    
    }
  }
  
  
  
  
  function get_cloudfront_secure( $media ) {
    $aArgs = func_get_args();
    $aArgs = $aArgs[1];

    if( !($aArgs instanceof flowplayer_frontend) && isset($aArgs['dynamic']) && $aArgs['dynamic'] ) {
      $media = $this->get_cloudfront_secure_url($media, apply_filters('fv_player_secure_link_cloudfront_timeout', 900), isset($aArgs['flash']) && $aArgs['flash'] ? true : false );
    }
    
    return $media;
  }
  
  
  
  
  function get_cloudfront_secure_url( $media, $time = 172800, $flash = false ) {
    if( stripos($media,'?Expires=') !== false && stripos($media,'&Signature=') !== false ) return $media;
    
    if( $this->_get_option( array('pro','cf_key_id') ) && $this->_get_option( array('pro','cf_pk') ) ) {
      $bIsCloudFrontDomain = false;
      $aDomains = explode( ',', $this->_get_option( array('pro','cf_domain') ) ); //  todo: test!
      if( count($aDomains) > 0 ) {
        foreach( $aDomains AS $sDomain ) {
          if( stripos($media, trim($sDomain) ) !== false ) {
            $bIsCloudFrontDomain = true;
          }
        }
      }
  
      if( !$bIsCloudFrontDomain && !$this->is_rtmp($media) ) {
        return $media;
      }
      
      if( !$this->is_rtmp($media) ) {
        $media = str_replace( ' ', '%20', $media );
      }
      
      $keyPairId = $this->_get_option( array('pro','cf_key_id') );
      $expires = time() + $time;  //  todo: use video duration

      $media_prepared = $this->strip_rtmp_ext($media);
   
      //$sURL = str_replace(array('+', '=', '/'), array('-', '_', '~'), $sURL);
      /*$sURL = str_replace('%2F', '/', $sURL);
      $sURL = str_replace('%2B', '+', $sURL);*/   
      $json = '{"Statement":[{"Resource":"'.$media_prepared.'","Condition":{"DateLessThan":{"AWS:EpochTime":' . $expires . '}}}]}';
                  
      // create the private key
      $key = openssl_get_privatekey($this->_get_option( array('pro','cf_pk') ));
      if( $key ) {
        openssl_sign($json, $signed_policy, $key);
         
        openssl_free_key($key);
         
        $base64_signed_policy = base64_encode($signed_policy);
        $signature = str_replace(array('+', '=', '/'), array('-', '_', '~'), $base64_signed_policy);
         
        if( $flash ) {
          $media = str_replace( '+', '%2B', $media);
        }
        $media = $media . '?Expires=' . $expires . '&Signature=' . $signature . '&Key-Pair-Id=' . $keyPairId;
      }
    }
   
    return $media;
  }
  

  
  
  function get__transient_name( $type = false ) {
    if( !$type ) {
      return '';
    }
    if( strcmp($type,'vimeo') == 0 ) {
      return 'fv_player_pro_vimeo_'.substr(md5($this->get__vimeo_key() . $this->_get_option('key')), 0, 16);
    }
    return '';
  }
  
  
  
  
  function get__vimeo_key() {
    if( defined('FV_PLAYER_VIMEO_KEY') ) {
      return FV_PLAYER_VIMEO_KEY;
    }
    
    if( $this->_get_option( array('pro','vimeo_at') ) ) {
      return $this->_get_option( array('pro','vimeo_at') );
    }
    
    return false;
  }
  
  
  
	
	function get__XML_value( $path, $xml, $number = 0 ) {
		$aItems = array();
		foreach( $xml->xpath( $path ) AS $key => $duration ) {
			$xmlDuration = simplexml_load_string($duration->asXML());
			if( $number === 0 ) {
				return (string)$xmlDuration;
			} else {
				$aItems[] = (string)$xmlDuration; 
			}
		}					
		
		if( $aItems ) {
			return $aItems;
		}
		
		return false;
	}




  function hflip_button($aButtons) {
    global $fv_fp;
    if( isset($fv_fp->aCurArgs['hflip']) ) {
      $aButtons[] = "<ul class='fv-player-hflip'><li><a href='#'>" . __('Flip', 'fv-player-pro') . "</a></li></ul>";
    }
    return $aButtons;
  }  
  
  
  
  
  public static function hms_to_seconds( $hms ) {
    $seconds = 0;
    
    $aDigits = explode( ':', $hms );
    
    if( count($aDigits) == 3 && preg_match( '~([0-9]{2}):([0-9]{2}):{1,2}([0-9]{2})[,.]([0-9]{3})~', $hms, $parsed ) ) {  //  00:00:34.790
      $seconds += $parsed['3'];
      $seconds += $parsed['2'] * 60;
      $seconds += $parsed['1'] * 60 * 60;
      
    } else if( count($aDigits) == 2 && preg_match( '~([0-9]{2}):{1,2}([0-9]{2})[,.]([0-9]{3})~', $hms, $parsed ) ) { //  00:34.790
      $seconds += $parsed['2'];
      $seconds += $parsed['1'] * 60;
      
    } else if( count($aDigits) == 1 && preg_match( '~([0-9]{2})[,.]([0-9]{3})~', $hms, $parsed ) ) { //  34.790
      $seconds += $parsed['1'];
      
    }
    
    return $seconds;
  }
  
  
  
  
  function interface_options() {
    ?>
    <?php $this->_get_checkbox(__('Chapters',    'fv-player-pro'), array('pro','interface','chapters'), __('Supports VTT chapters.', 'fv-player-pro') ); ?>
    <?php $this->_get_checkbox(__('DRM Text',    'fv-player-pro'), array('pro','interface','copy_text') ); ?>
    <?php $this->_get_checkbox(__('Horizontal Flip',    'fv-player-pro'), array('pro','interface','hflip'), __('Adds shortcode editor option for a user button to flip video horizontally.', 'fv-player-pro') ); ?>
    <?php $this->_get_checkbox(__('AB Loop',            'fv-player-pro'), array('interface','ab'), __('Adds shortcode editor option for AB loop function', 'fv-player-pro') ); ?>
    <?php
  }




  function is_dynamic_item( $sURL ) { //  todo: check!
    if( $this->_get_option( array('pro','cf_domain') ) && $this->_get_option( array('pro','cf_key_id') ) && $this->_get_option( array('pro','cf_pk') )){
      $aDomains = explode( ',', $this->_get_option( array('pro','cf_domain') ) ); //  todo: test!
      if( count($aDomains) > 0 ) {
        foreach( $aDomains AS $sDomain ) {
          if( stripos($sURL, trim($sDomain) ) !== false ) {
            return true;
          }
        }
      }   
      
    }
    return false;
  }
  
  
  
  
  function is_rtmp( $sURL ) {
    return preg_match( '~^(mp4|flv):~', $sURL );
  }
  
  
  
  
  function is_vimeo( $sURL ) {
    $check = preg_match( "~vimeo.com/(?:video/|moogaloop\.swf\?clip_id=)?(\d+)~i", $sURL, $aDynamic );
    if( $check ) {
      global $fv_fp;
      $fv_fp->load_dash = true;
    }
    return $check;
  }
  
  
  
  
  function is_youtube( $sURL ) {

    if(
      (
        preg_match( "~youtube.com/.*?v=([a-zA-Z0-9_-]+)(?:\?|$|&)~i", $sURL, $aDynamic ) ||
        preg_match( "~youtu.be/([a-zA-Z0-9_-]+)(?:\?|$|&)~i", $sURL, $aDynamic ) ||
        preg_match( "~youtube.com/embed/([a-zA-Z0-9_-]+)(?:\?|$|&)~i", $sURL, $aDynamic )
      ) && !$this->_get_option( array('pro','youtube_disable') )
    ) {
      $this->bYoutube = true;
      //var_dump('is_youtube',$sURL,$aDynamic);
      return $aDynamic;
    }    
    return false;
  }  


  
  
  
  function quality_attributes( $aAttributes ) {
    global $fv_fp;

    $aArgs = func_get_args();
    if( $this->_get_option( array('pro','vimeo_qs') ) && isset($aArgs[2]->aCurArgs['src']) && $this->is_vimeo($aArgs[2]->aCurArgs['src']) ) {
      $aAttributes['data-qsel'] = implode( ',', array_keys($this->aVimeoQualities) );
      
    } else if( isset($aArgs[2]->aCurArgs['qsel']) && $aQualities = $this->func__get_qualities() ) {
      $aAttributes['data-qsel'] = implode( ',', array_keys($aQualities) );
      
    }
    if( isset($aArgs[2]->aCurArgs['src']) && $this->is_youtube($aArgs[2]->aCurArgs['src']) ) {
      $aAttributes['data-engine'] = 'fvyoutube';
      $fv_fp->aCurArgs['engine'] = 'fvyoutube';    
      $aAttributes['class'] .= ' is-youtube';
      if( $this->_get_option( array('pro','yt_logo') ) ) {
        $aAttributes['class'] .= ' is-youtube-nl';
      }
    }    
    return $aAttributes;
  }
  
  
  
  
  function quality_buttons($aButtons) {
    global $fv_fp;

    $sOutput = false;
    if($this->_get_option( array('pro','vimeo_qs') ) && isset($fv_fp->aCurArgs['src']) && $this->is_vimeo($fv_fp->aCurArgs['src']) ) {
      $i = 0;
      foreach( $this->aVimeoQualities AS $sQuality => $sLabel ) {
        $sOutput .= "<li><a href='#' data-quality='$sQuality'".($i==0 ? ' class="current"' : '').">$sLabel</a></li>";
        $i++;
      }
      
    } else if( $this->_get_option( array('pro','youtube_qs') ) && isset($fv_fp->aCurArgs['engine']) && $fv_fp->aCurArgs['engine'] == 'fvyoutube' ) {
      $sOutput = '';
      
    } else if( isset($fv_fp->aCurArgs['qsel']) && $aQualities = $this->func__get_qualities() ) {
      $i = 0;
      foreach( $aQualities AS $sQuality => $sLabel ) {
        $sOutput .= "<li><a href='#' data-quality='$sQuality'".($i==0 ? ' class="current"' : '').">$sLabel</a></li>";
        $i++;
      }
      
    }
    
    if( $sOutput !== false ) {
      $aButtons[] = "<ul class='fv-player-quality'>".$sOutput."</ul>";
    }

    return $aButtons;
  }
  
  
  
  
  function quality_media( $aMedia ) {
    $aArgs = func_get_args();
    
    if( !isset($aArgs[1]->aCurArgs['qsel']) || !$aQualities = $this->func__get_qualities() ) return $aMedia;
    
    $aQualityMedia = array();
    foreach($aMedia AS $aFileURL ) {
      $sDefaultQuality = false;
      foreach( $aQualities AS $key => $item ) {
        if( stripos($aFileURL, (string)$key) ) {
          $sDefaultQuality = (string)$key;
          break;
        }
      }

      foreach( $aQualities AS $key => $item ) {
        $aQualityMedia[] = str_replace( $sDefaultQuality, (string)$key, $aFileURL );
      }      
    }
 
    return $aQualityMedia;
  }
  
  function fetch_vimeo_yt_data($video, $post_id = false) {

    if ($this->is_vimeo($video) && $this->get__vimeo_key() ) {
      
      $fv_flowplayer_meta = false;
      if( $post_id ) {
        $fv_flowplayer_meta = get_post_meta($post_id, flowplayer::get_video_key($video), true);
        if( !$fv_flowplayer_meta || !isset($fv_flowplayer_meta['date']) || ( $fv_flowplayer_meta['date'] + 3600 ) < time() ) {
          $fv_flowplayer_meta = false;
        }
      }
      
      if( !$fv_flowplayer_meta ) {
        $tStart = microtime(true);
        
        require_once( dirname(__FILE__) . '/includes/vimeo.php');
        $hVimeo = new FVVimeo(false, false, $this->get__vimeo_key() );
        $result = $hVimeo->request('/videos/' . $this->func__get_vimeo_id($video));
        
        if (!isset($result['body'])) {
          return false;
        }
        $aVimeoInfo = $result['body'];
              
        $fv_flowplayer_meta = ($fv_flowplayer_meta) ? $fv_flowplayer_meta : array();
        $fv_flowplayer_meta['duration'] = ( isset($aVimeoInfo['duration']) ) ? $aVimeoInfo['duration'] : false; // isn't there a better way?
        if( isset($aVimeoInfo['pictures']['sizes']) ) {
          $iCount = count($aVimeoInfo['pictures']['sizes']);  
          $fv_flowplayer_meta['splash'] = ( isset($aVimeoInfo['pictures']['sizes'][$iCount-1]) ) ? $aVimeoInfo['pictures']['sizes'][$iCount-1]['link'] : false;
        } else {
          $fv_flowplayer_meta['splash'] = ( isset($aVimeoInfo['pictures'][0]) ) ? $aVimeoInfo['pictures'][0]['link'] : false;
        }      
        $fv_flowplayer_meta['caption'] = isset($aVimeoInfo['name']) ? $aVimeoInfo['name'] : false;
        $fv_flowplayer_meta['date'] = time();
        $fv_flowplayer_meta['check_time'] = microtime(true) - $tStart;
          
        if ($post_id) {  
          update_post_meta($post_id, flowplayer::get_video_key($video), $fv_flowplayer_meta);
        }
      }
      
      $videoData = false;
      if( $fv_flowplayer_meta['caption'] && $fv_flowplayer_meta['splash'] ) {
        $videoData = array(
            'name' => str_replace( array(';','[',']'), array('\;','(',')'), htmlspecialchars($fv_flowplayer_meta['caption']) ),
            'thumbnail' => $fv_flowplayer_meta['splash'],
        );
      }
      return $videoData;
    
    } else if ( $this->is_youtube($video) && $this->_get_option( array('pro','youtube_key') )) {
      
      $fv_flowplayer_meta = false;
      if( $post_id ) {
        $fv_flowplayer_meta = get_post_meta($post_id, flowplayer::get_video_key($video), true);
        if( !$fv_flowplayer_meta || !isset($fv_flowplayer_meta['date']) || ( $fv_flowplayer_meta['date'] + 24 * 3600 ) < time() || !$fv_flowplayer_meta['duration'] && ( $fv_flowplayer_meta['date'] + 60 ) < time() ) {
          $fv_flowplayer_meta = false;
        }
      }
      
      if( !$fv_flowplayer_meta ) {
        $tStart = microtime(true);
        $aId = $this->is_youtube($video);
        
        $response = wp_remote_get( 'https://www.googleapis.com/youtube/v3/videos?part=snippet,contentDetails&id=' . $aId[1] . '&key=' . $this->_get_option( array('pro','youtube_key') ), array( 'sslverify' => false ) );        
        $obj = is_wp_error($response) ? false : @json_decode( wp_remote_retrieve_body($response) );
        
        $fv_flowplayer_meta = ($fv_flowplayer_meta) ? $fv_flowplayer_meta : array();
        if ( $obj && isset($obj->items[0]->contentDetails->duration)) {
          if (class_exists('DateInterval')) {
            $interval = new DateInterval($obj->items[0]->contentDetails->duration);
            $fv_flowplayer_meta['duration'] = date_create('@0')->add($interval)->getTimestamp();
          } else {
            if (preg_match_all('/(\d+)/', $obj->items[0]->contentDetails->duration, $parts)) {
              if (isset($parts[0][0]) && isset($parts[0][1]) && isset($parts[0][2])) {
                $seconds = 3600 * $parts[0][0];
                $seconds += 60 * $parts[0][1];
                $seconds += $parts[0][2];
              } else if (isset($parts[0][0]) && isset($parts[0][1])) {
                $seconds = 60 * $parts[0][0];
                $seconds += $parts[0][1];
              } else {
                $seconds = $parts[0][0];
              }
            }
            $fv_flowplayer_meta['duration'] = $seconds;
          }
        }
        
        if( isset($obj->error) && !empty($obj->error->message) ) {
          update_option('fv_player_pro_youtube_error',date('r').": ".$obj->error->message);
        }
        
        //  YouTube splash screens come in various sizes and often with black borders. So we use the maxres image to determine image aspect ratio and then look for matching image
        if( $obj && isset($obj->items[0]) && isset($obj->items[0]->snippet->thumbnails) ) {
          $thumbs = $obj->items[0]->snippet->thumbnails;
          $ratio = isset($thumbs->maxres) && intval($thumbs->maxres->width) > 0 && intval($thumbs->maxres->height) > 0 ? $thumbs->maxres->height/$thumbs->maxres->width : false;
          foreach( (array)$thumbs AS $k => $v ) {            
            if( !$ratio || $v->height/$v->width == $ratio ) {
              $fv_flowplayer_meta['splash'] = $v->url;
              if( $v->width > 600 ) break;
            }
          }          
        }
        
        $fv_flowplayer_meta['caption'] = $obj && isset($obj->items[0]) && isset($obj->items[0]->snippet->title) ? $obj->items[0]->snippet->title : false;
        $fv_flowplayer_meta['check_time'] = microtime(true) - $tStart;
        
        if ($post_id) {
          update_post_meta($post_id, flowplayer::get_video_key($video), $fv_flowplayer_meta);
        }
      }
      
      $videoData = false;
      if( $fv_flowplayer_meta['splash'] && $fv_flowplayer_meta['caption'] ) {
        $videoData = array(
            'name' => htmlspecialchars( str_replace( array(';','[',']'), array('\;','(',')'), $fv_flowplayer_meta['caption']) ),
            'thumbnail' => $fv_flowplayer_meta['splash'],
        );
      }
      return $videoData;
    } else {
      return false;
    }
  }
  
  
  function save_post($sPost) {
    $post_id = get_the_ID();
    
    if (!method_exists('FV_Player_Checker', 'get_videos') || (!$this->get__vimeo_key() && !$this->_get_option( array('pro','youtube_key') ))) {
      return $sPost;
    }

    $aShortcodes = array();
    $aShortcodesNew = array();
    preg_match_all('/\[fvplayer[^\]]*\]/', $sPost, $aShortcodes);
    
    $aMeta = get_post_custom($post_id);
    if( $aMeta && is_array($aMeta) && count($aMeta) > 0) {
      $meta_values = '';
      foreach( $aMeta AS $values ) {
        $meta_values .= implode( $values );
      }
      
      if( preg_match_all( '~\[(?:flowplayer|fvplayer).*?\]~', $meta_values, $meta_matches ) ) {
        $aShortcodes[0] = array_merge($aShortcodes[0], $meta_matches[0]);
      }
    }
    
    foreach ($aShortcodes[0] AS $key => $shortcode) {
      $bChanged = false;
      $shortcode = preg_replace('/\\"]/', '" ]', $shortcode);
      $shortcode = stripslashes($shortcode);
      if(preg_match('/popup="([^\d]*)"/',$shortcode) && !preg_match('/popup="(no|random)"/',$shortcode)){
        unset($aShortcodes[0][$key]);
        continue;
      }
      $attrs = shortcode_parse_atts($shortcode);
      if( !isset($attrs['src']) ) continue;

      $aCaptions = isset($attrs['caption']) ? explode(';', $attrs['caption']) : array();

      $videoData = $this->fetch_vimeo_yt_data($attrs['src'], $post_id); //  we run this even if caption or splash is not going to change as we might need to get new data, such as duration. The function only makes the HTTP call once per hour.
      
      $bNewCaption = (!isset($aCaptions[0]) || isset($aCaptions[0]) && empty($aCaptions[0]));
      $bNewSplash = (!isset($attrs['splash']) || isset($attrs['splash']) && empty($attrs['splash']));
      if ($bNewCaption || $bNewSplash) {        
        if ($bNewCaption && !empty($videoData['name'])) {
          $aCaptions[0] = htmlentities($videoData['name']);
          $bChanged = true;
        }
        if ($bNewSplash && !empty($videoData['thumbnail'])) {
          $attrs['splash'] = $videoData['thumbnail'];
          $bChanged = true;
        }
      }

      if (isset($attrs['playlist'])) {
        $attrs['playlist'] = explode(';', $attrs['playlist']);
        foreach ($attrs['playlist'] AS $playlistkey => $sItem) {
          $aItem = explode(',', $sItem);
          $bNewCaption = (!isset($aCaptions[$playlistkey + 1]) || isset($aCaptions[$playlistkey + 1]) && empty($aCaptions[$playlistkey + 1]));

          $videoData = $this->fetch_vimeo_yt_data($aItem[0], $post_id);
          if(!$videoData){
            continue;
          }

          $bNewSplash = (count($aItem) == 1 && $videoData );
          if ($bNewCaption || $bNewSplash) {

            if ($bNewCaption) {
              $aCaptions[$playlistkey + 1] = htmlentities($videoData['name']);
              $bChanged = true;
            }
            if ($bNewSplash) {
              $attrs['playlist'][$playlistkey] = $sItem . ( isset($videoData['thumbnail']) ? ',' . $videoData['thumbnail'] : '' );
              $bChanged = true;
            }
          }
        }
        $attrs['playlist'] = implode(';', $attrs['playlist']);
      }
      if(!empty($aCaptions)){
        $attrs['caption'] = implode(';', $aCaptions);
      }

      $aShortcodesNew[$key] = $attrs[0];
      $sRemains = '';
      foreach ($attrs as $attKey => $attVal) {
        if (is_int($attKey) ) {
          if($attKey){
             $sRemains .= ' '.$attVal;
          }
          continue;
        }
        $aShortcodesNew[$key].= ' ' . $attKey . '=\\"' . $attVal . '\\"';        
      }
      $aShortcodesNew[$key] .= trim($sRemains);
      
      if($bChanged){
        $sPost = str_replace($aShortcodes[0][$key], $aShortcodesNew[$key], $sPost);
      }
    }
    
    return $sPost;
  }
  
	

	
	function scripts() {
    global $post;

    //  todo: something better for video checker
    if( isset($GLOBALS['fv_fp_scripts']) && isset($GLOBALS['fv_fp_scripts']['fv_flowplayer_admin_test_media']) && count($GLOBALS['fv_fp_scripts']['fv_flowplayer_admin_test_media']) ) {
      foreach( $GLOBALS['fv_fp_scripts']['fv_flowplayer_admin_test_media'] AS $key => $item ) {
        if( !is_array($item[0]) && ( $this->is_vimeo(stripslashes($item[0])) || $this->is_youtube(stripslashes($item[0])) ) ) {
          unset( $GLOBALS['fv_fp_scripts']['fv_flowplayer_admin_test_media'][$key] );
        }
      }      
    }
    
    if(
      isset($GLOBALS['fv_fp_scripts']) ||
      $this->_get_option( 'js-everywhere' )
    ) {
      $sMin = file_exists(dirname(__FILE__) . '/js/fv_player_pro.dev.js') ? 'dev' : 'min';
      wp_enqueue_script('fv_player_pro', plugins_url('/js/fv_player_pro.' . $sMin . '.js', __FILE__), array('jquery','flowplayer'), $this->version, true);
      
      $aCFDomains = false;
      if( $this->_get_option( array('pro','cf_domain') ) ) {
        $aCFDomains = explode( ',', $this->_get_option( array('pro','cf_domain') ) ); //  todo: test!
        $aCFDomains = array_map( 'trim', $aCFDomains );
      }
      $bVimeoDirectAjax = $this->_get_option( array('pro','vimeo_direct_ajax') );
      
      if( $this->_get_option('js-everywhere') ) $this->bYoutube = 1;

      $aOptions = array(
        'ajaxurl' => site_url( 'wp-admin/admin-ajax.php' ),
        'vimeo_ajax_url' => $bVimeoDirectAjax && defined('FV_PLAYER_VIMEO_KEY') ? plugins_url('fv-vimeo-ajax.php', __FILE__) : false,
        'autoplay_once' => $this->is_option_enabled('autoplay_once'),
        'dynamic_domains' => apply_filters('fv_player_pro_video_ajaxify_domains',$aCFDomains),
        'debug' => $this->is_option_enabled('vimeo_debug'),
        'video_ads' => $this->aVideoAds,
        'v_dash' => !$this->_get_option( array('pro','vimeo_dash_disable') ),
        'youtube' => $this->bYoutube,
        'youtube_nl' => $this->_get_option( array('pro','yt_logo') ),
        'youtube_ads_disable' => $this->_get_option( array('pro','youtube_ads_disable') )
      );

      // we cannot get default server without WordPress, so we need to add it to options here
      if ( $this->_get_option(array('pro','vimeo_location') ) ) {
        $aOptions['default_api_server'] = $this->_get_option(array('pro','vimeo_location'));
      } else {
        $aOptions['default_api_server'] = '';
      }

      if( $this->use_old_code() ){
        $aOptions['chapters'] = $this->aChapters;
      }
      
      $aOptions['video_ads_skip'] = 5;
      if( is_numeric( $this->_get_option( array('pro','video_ads_skip') ) ) ) {
        $aOptions['video_ads_skip'] = intval($this->_get_option( array('pro','video_ads_skip') ));
      }
      
      $aOptions['video_ads_skip_minimum'] = 10;
      if( is_numeric( $this->_get_option( array('pro','video_ads_skip_minimum') ) ) ) {
        $aOptions['video_ads_skip_minimum'] = intval($this->_get_option( array('pro','video_ads_skip_minimum') ));
      }
      
      if( $this->_get_option( array('pro','video_ads_once') ) ) {
        $aOptions['video_ads_once'] = true;
      }
      
      if( $this->_get_option('subtitleOn')) {
        $aOptions['subtitleOn'] = true;
      }
      
      if( ( $this->_get_option( array('pro','autoplay_scroll') ) ) || isset($post) && get_post_meta($post->ID, 'fv_flowplayer_scroll_autoplay',true) ) {
         $aOptions['autoplay_scroll'] = true;
      }
      
      if( $this->_get_option( array('pro','copy_text_time') ) && $this->_get_option( array('pro','copy_text_time') ) != 5 ) {
         $aOptions['copy_text_time'] = $this->_get_option( array('pro','copy_text_time') );
      }
      

      wp_localize_script( 'fv_player_pro', 'fv_player_pro', $aOptions );
      wp_localize_script( 'fv_player_pro', 'fv_player_pro_js_translations', $this->fv_player_pro_get_js_translations() );
    }
  }
  
  
  function styles() {
    if( is_admin() && did_action('admin_footer') ) {
      echo "<link rel='stylesheet' id='fv-player-pro'  href='".plugins_url( '/css/style.css', __FILE__ )."?ver=".$this->version."' type='text/css' media='all' />\n";
    } else if( wp_style_is('fv_flowplayer') && !wp_style_is('fv-player-pro') ){ // only enqueue if FV Player CSS is there and if not already enqueued
      wp_enqueue_style( 'fv-player-pro', plugins_url( '/css/style.css', __FILE__ ), array('fv_flowplayer'), $this->version );
    }
  }

  
  
  
  function set_file_type( $type ) {
    $args = func_get_args();
    if( isset($args[1]) ) {
      if( $this->is_youtube($args[1]) ) {
        $type = "video/youtube";
      } else if(  $this->is_vimeo($args[1]) ) {
        $type = "video/fv-mp4";
      } else if(  $this->is_dynamic_item($args[1]) ) {
        $type = str_replace( 'video/', 'video/fv-', $type );
      }
    }
    return $type;
  }
	
	
  
  
  function set_player_type( $player_type ) {
    $args = func_get_args();
    
    if( (!isset($args[4]['playlist']) || !$args[4]['playlist']) && function_exists('is_amp_endpoint') && is_amp_endpoint() ) {
      return $player_type;
    }    
    
    if( isset($args[3]) && count($args[3]) > 0 ) {
      $aVideos = $args[3];
    } else {
      $aVideos[] = $args[2];  
    }

    foreach( $aVideos AS $sVideo ) {
      if( is_array($sVideo) ) {
        $sVideo = $sVideo['sources'][0]['src'];
      }
      if( is_array($sVideo) ) {
        $aVideo = array_values($sVideo);
        $sVideo = $aVideo['sources'][0]['src'];
      }
      
      if( $this->is_option_enabled('vimeo') && $this->is_vimeo($sVideo) ) {
        if( $this->_get_option( array('pro','vimeo_iframe') ) && ( empty($args[4]['engine']) || $args[4]['engine'] != 'html5' ) ){
          $player_type = 'vimeo';
        }else{
          $player_type = 'video';
        }

      } else if( $this->is_youtube($sVideo) ) {
        $player_type = 'video';
      }
    }

    return $player_type;
  }
  
  
  
  
  function settings_save( $aSettings ) {
    $aArgs = func_get_args();
    $aOldSettings = $aArgs[1];

    if( isset($_POST['fv_player_admin_pro_quality_alive']) ) {
      $aSettings['pro']['quality'] = '';
      if( isset($_POST['aQualityItemNames']) && isset($_POST['aQualityItemLabel']) ) {
        $sQuality = '';
        foreach( $_POST['aQualityItemNames'] AS $key => $item ) {
          $sQuality .= str_replace( ',', '', trim($item) ).",".str_replace( ',', '', trim($_POST['aQualityItemLabel'][$key]) )."\n";
        }
        $aSettings['pro']['quality'] = trim($sQuality);;
        unset($aSettings['aQualityItemNames']);
        unset($aSettings['aQualityItemLabel']);
      }
    }
  
    if( isset($_POST['fv_player_admin_pro_video_ads_alive']) ) {    
      $aSettings['pro']['video_ads'] = array();
      if( isset($_POST['aVideoAdDisabled']) ) {
        foreach( $_POST['aVideoAdDisabled'] AS $key => $item ) {   
          if( trim($_POST['aVideoAd_mp4'][$key]) == '' && trim($_POST['aVideoAdClick'][$key]) == '' && trim($_POST['aVideoAd_name'][$key]) == '' )  continue;
          $aSettings['pro']['video_ads'][] = array(
                                                  'videos' => array(                                                    
                                                    'mp4' => trim(stripslashes($_POST['aVideoAd_mp4'][$key])),
                                                    ),
                                                  'disabled' => $item,
                                                  'name' => trim($_POST['aVideoAd_name'][$key]),
                                                  'click' => trim($_POST['aVideoAdClick'][$key])
                                                  );
        }
      }
      
      unset($aSettings['aVideoAd_name']);
      unset($aSettings['aVideoAd_mp4']);
      unset($aSettings['aVideoAd_webm']);
      unset($aSettings['aVideoAd_ogv']);
      unset($aSettings['aVideoAd_hls']);
      unset($aSettings['aVideoAd_flash']);
      unset($aSettings['aVideoAd_rtmp']);
      unset($aSettings['aVideoAdClick']);
      unset($aSettings['aVideoAdDisabled']);
    }

    if( isset($aOldSettings['pro']['cf_pk']) && ( !isset($aSettings['pro']['cf_pk']) || strlen(trim($aSettings['pro']['cf_pk'])) == 0 ) ) {
      $aSettings['pro']['cf_pk'] = $aOldSettings['pro']['cf_pk'];
    }
    
    if( isset($aSettings['pro']['ppv_description']) ) {
      $aSettings['pro']['ppv_description'] = stripslashes($aSettings['pro']['ppv_description']);
    }
    
    $this->clear_cache(true);
    
    return $aSettings;
  }
  
  
  
  
  function shortcode( $attrs ) {
    $aArgs = func_get_args();
    
    if( isset($aArgs[2]) && isset($aArgs[2]['qsel']) ) {
      $attrs['qsel'] = $aArgs[2]['qsel'];
    }
    
    if( isset($aArgs[2]) && isset($aArgs[2]['ads']) ) {
      $attrs['preroll'] = $aArgs[2]['ads'];
    }
    if( isset($aArgs[2]) && isset($aArgs[2]['preroll']) ) {
      $attrs['preroll'] = $aArgs[2]['preroll'];
    }
      if( isset($aArgs[2]) && isset($aArgs[2]['postroll']) ) {
      $attrs['postroll'] = $aArgs[2]['postroll'];
    } 
        
    if( isset($aArgs[2]) && isset($aArgs[2]['chapters']) ) {
      $attrs['chapters'] = $aArgs[2]['chapters'];
    }
    
    if( isset($aArgs[2]) && isset($aArgs[2]['transcript']) ) {
      $attrs['transcript'] = $aArgs[2]['transcript'];
    }
    
    if( isset($aArgs[2]) && isset($aArgs[2]['ab']) ) {
      $attrs['ab'] = $aArgs[2]['ab'];
    }

    if( isset($aArgs[2]) && isset($aArgs[2]['hflip']) ) {
      $attrs['hflip'] = $aArgs[2]['hflip'];
    }
    
    if (isset($aArgs[2]) && isset($aArgs[2]['copy_text'])) {
      $attrs['copy_text'] = $aArgs[2]['copy_text'];
    }

    if( isset($aArgs[2]) && is_array($aArgs[2]) ) {
      foreach( $aArgs[2] AS $key => $value ) {
        if( $key == 'end' && $value == 'show' ) continue;
        if( stripos($key,'start') === 0 || stripos($key,'end') === 0 ) {
          $attrs[$key] = $value;
        }
      }
    }
    
    if(isset($aArgs[2]['hlskey'])){
      $attrs['hlskey'] = $aArgs[2]['hlskey'];
    }

    return $attrs;
  }
  
  
  
  
  function shortcode_editor_actions() {

    $bHflip = $this->is_option_enabled( array( 'interface', 'hflip' ) );
    $bQualities = $this->func__get_qualities();
    $bVideoAds = $this->func__get_video_ads();
    $bAwsDecrypt = $this->_get_option( array('pro','elastic_secret') );
    
    if( $this->shortcode_editor_is_old() && ( $bQualities || $bVideoAds || $bAwsDecrypt ) ) :
  ?>
      <tr>
        <th scope="row" width="18%"></th>
        <td style="text-align: left; padding: 10px 0; text-transform: uppercase;"><?php _e('Pro features', 'fv-player-pro'); ?></td>
      </tr>
    <?php endif; ?>
    
    <tr<?php if( !$bVideoAds ) echo ' style="display: none"'; ?>>
      <th scope="row" class="label"><label for="fv_wp_flowplayer_field_video_ads" class="alignright"><?php _e('Pre-roll Ad', 'fv-player-pro'); ?></label></th>
      <td class="field">
        <?php $this->admin__select_video_ads( array( 'id'=>'fv_wp_flowplayer_field_video_ads', 'show_default' => true )); ?>
      </td>
    </tr>
    <tr<?php if( !$bVideoAds ) echo ' style="display: none"'; ?>>
      <th scope="row" class="label"><label for="fv_wp_flowplayer_field_video_ads_post" class="alignright"><?php _e('Post-roll Ad', 'fv-player-pro'); ?></label></th>
      <td class="field">
        <?php $this->admin__select_video_ads( array( 'id'=>'fv_wp_flowplayer_field_video_ads_post', 'show_default' => true )); ?>
      </td>
    </tr>
    
    <?php if( $this->shortcode_editor_is_old() ) : ?>
      <tr>
        <th scope="row" class="label"><label for="fv_wp_flowplayer_field_ab" class="alignright"><?php _e('AB Loop', 'fv-player-pro'); ?></label></th>
        <td class="field">
          <input type="checkbox" id="fv_wp_flowplayer_field_ab" name="fv_wp_flowplayer_field_ab" />
        </td>
      </tr>
      <tr<?php if( !$bHflip ) echo ' style="display: none"'; ?>>
        <th scope="row" class="label"><label for="fv_wp_flowplayer_field_hflip" class="alignright"><?php _e('Horizontal Flip', 'fv-player-pro'); ?></label></th>
        <td class="field">
          <input type="checkbox" id="fv_wp_flowplayer_field_hflip" name="fv_wp_flowplayer_field_hflip" />
        </td>
      </tr>
      <tr<?php if( !$bQualities ) echo ' style="display: none"'; ?>>
        <?php if($bQualities) : ?><script>fv_player_pro_has_qualities = true;</script><?php endif; ?>
        <th scope="row" class="label"><label for="fv_wp_flowplayer_field_qsel" class="alignright"><?php _e('Quality Switching', 'fv-player-pro'); ?></label></th>
        <td class="field">
          <input type="checkbox" id="fv_wp_flowplayer_field_qsel" name="fv_wp_flowplayer_field_qsel" />
          <script>var fv_player_shortcode_editor_qualities = <?php echo json_encode( $aQualities = $this->func__get_qualities() ); ?>;</script>
          <a href="#" onclick="return fv_player_shortcode_editor_qs()"><?php _e('Show hint', 'fv-player-pro'); ?></a>
        </td>
      </tr>
      <tr id="fv_player_shortcode_editor_qualities_sample_wrap" style="display: none">
        <th></th>
        <td><div id="fv_player_shortcode_editor_qualities_sample"></div></td>
      </tr>         
      <tr<?php if( !$bAwsDecrypt ) echo ' style="display: none"'; ?>>
        <th scope="row" class="label" valign="top"><label for="fv_wp_flowplayer_hlskey" class="alignright"><?php _e('Encrypted HLS', 'fv-player-pro'); ?></label></th>
        <td class="field">
          <input id="fv_wp_flowplayer_hlskey" class="text" type="text" name="fv_wp_flowplayer_hlskey" placeholder="<?php _e('Decryption key', 'fv-player-pro'); ?>" style="width: 93%" />
          <textarea id="fv_wp_flowplayer_hlskey_cryptic" name="fv_wp_flowplayer_hlskey_cryptic" class="text with-button" placeholder="<?php _e('Encryption key', 'fv-player-pro'); ?>" style="width: 93%"></textarea>
          <br />
          <a id="button-hls-decrypt" href="#"><?php _e('Decrypt', 'fv-player-pro'); ?></a>
        </td>
      </tr>
    <?php endif;
  }
  
  
  
  
  function shortcode_editor_options() {

    $bAwsDecrypt = $this->_get_option( array('pro','elastic_secret') );
    $bHflip = $this->is_option_enabled( array( 'interface', 'hflip' ) );
    $bQualities = $this->func__get_qualities();
    $bDrmText = $this->is_option_enabled( array( 'interface', 'copy_text' ) );
    
    if(function_exists('fv_player_shortcode_row')){
      fv_player_shortcode_row( array( 'label' => 'AB Loop', 'name' => 'ab' ) ); 
    }
    ?>
      <tr<?php if( !$bHflip ) echo ' style="display: none"'; ?>>
      <th scope="row" class="label"><label for="fv_wp_flowplayer_field_hflip" class="alignright"><?php _e('Horizontal Flip', 'fv-player-pro'); ?></label></th>
      <td class="field">
        <input type="checkbox" id="fv_wp_flowplayer_field_hflip" name="fv_wp_flowplayer_field_hflip" />
      </td>
    </tr>
    <tr<?php if( !$bQualities ) echo ' style="display: none"'; ?>>
      <?php if($bQualities) : ?><script>fv_player_pro_has_qualities = true;</script><?php endif; ?>
      <th scope="row" class="label"><label for="fv_wp_flowplayer_field_qsel" class="alignright"><?php _e('Quality Switching', 'fv-player-pro'); ?></label></th>
      <td class="field">
        <input type="checkbox" id="fv_wp_flowplayer_field_qsel" name="fv_wp_flowplayer_field_qsel" />
        <script>var fv_player_shortcode_editor_qualities = <?php echo json_encode( $aQualities = $this->func__get_qualities() ); ?>;</script>
        <a href="#" onclick="return fv_player_shortcode_editor_qs()"><?php _e('Show hint', 'fv-player-pro'); ?></a>
      </td>
    </tr>
    <tr id="fv_player_shortcode_editor_qualities_sample_wrap" style="display: none">
      <th></th>
      <td><div id="fv_player_shortcode_editor_qualities_sample"></div></td>
    </tr>          
    <tr<?php if( !$bAwsDecrypt ) echo ' style="display: none"'; ?>>
      <th scope="row" class="label" valign="top"><label for="fv_wp_flowplayer_hlskey" class="alignright"><?php _e('Encrypted HLS', 'fv-player-pro'); ?></label></th>
      <td class="field">
        <input id="fv_wp_flowplayer_hlskey" class="text" type="text" name="fv_wp_flowplayer_hlskey" placeholder="<?php _e('Decryption key', 'fv-player-pro'); ?>" style="width: 93%" />
        <textarea id="fv_wp_flowplayer_hlskey_cryptic" name="fv_wp_flowplayer_hlskey_cryptic" class="text with-button" placeholder="<?php _e('Encryption key', 'fv-player-pro'); ?>" style="width: 93%"></textarea>
        <br />
        <a id="button-hls-decrypt" href="#"><?php _e('Decrypt', 'fv-player-pro'); ?></a>
      </td>
    </tr>
    <tr<?php if (!$bDrmText) echo ' style="display: none"'; ?>>
      <th scope="row" class="label"><label for="fv_wp_flowplayer_field_copy_text" class="alignright"><?php _e('DRM Text', 'fv-player-pro'); ?></label></th>
      <td class="field">
        <input type="checkbox" id="fv_wp_flowplayer_field_copy_text" name="fv_wp_flowplayer_field_copy_text" />
      </td>
    </tr>
    <?php
  }   
  
  
  
  
  function shortcode_editor_item() {

    $bStartEnd = $this->is_option_enabled( 'start_end' );
    $bChapters = $this->is_option_enabled( array( 'interface', 'chapters' ) );
    $bAllowUploads = $this->_get_option( 'allowuploads' );
    
    ?> 
    <tr<?php if( !$bStartEnd ) echo ' style="display: none"'; ?>>
      <th scope="row" class="label"><label for="fv_wp_flowplayer_field_start" class="alignright"><?php _e('Start/End', 'fv-player-pro'); ?></label></th>
      <td class="field" colspan="2">
        <input type="text" class="text half-field extra-field" id="fv_wp_flowplayer_field_start" name="fv_wp_flowplayer_field_start" />
        <input type="text" class="text half-field extra-field" id="fv_wp_flowplayer_field_end" name="fv_wp_flowplayer_field_end" />
        <span class="hint">(<abbr title="<?php _e('Enter hh:mm:ss. You may enter both or just one value, leave empty for full video.', 'fv-player-pro'); ?>">?</abbr>)</span>
      </td>
    </tr>
    <tr<?php if( !$bChapters ) echo ' style="display: none"'; ?>>
      <th scope="row" class="label"><label for="fv_wp_flowplayer_field_chapters" class="alignright"><?php _e('Chapters', 'fv-player-pro'); ?></label></th>
      <td class="field" colspan="2">
        <div class="fv-fp-chapter">               
           <input type="text" class="text with-button extra-field" id="fv_wp_flowplayer_field_chapters" name="fv_wp_flowplayer_field_chapters" value="" />
            <?php if ($bAllowUploads == 'true') { ?>
               <a class="button add_media" href="#"><span class="wp-media-buttons-icon"></span> <?php _e('Add Chapters', 'fv-player-pro'); ?></a>
               <a class="fv-fp-subtitle-remove" href="#" style="display: none">X</a>
             <?php }; ?>
        </div>
      </td>
    </tr>    
  <?php
  }
  
  
  
  
  function shortcode_editor_is_old() {
    global $fv_wp_flowplayer_ver;
    if( $this->is_option_enabled( array('interface','shortcode_editor_old') ) ) {
      return true;
    }
    
    if( version_compare($fv_wp_flowplayer_ver,'6.0.5.12') != 1 ) return true;
    
    return false;
  }
  
  
  
  
  function start_endtime($aItems){
    global $fv_fp;
    if( empty($aItems) ){
      return $aItems;
    }
    if( isset($fv_fp->aCurArgs) && isset($fv_fp->aCurArgs['startend']) ) {
      foreach( explode( ';', $fv_fp->aCurArgs['startend'] ) as $key => $value){
        $value = explode('-',$value);
        $aItems[$key]['fv_start'] = $value[0]; 
        $aItems[$key]['fv_end']   = isset($value[1]) ? $value[1] : '' ; 
      }; 
    }
      
    return $aItems;
  }
  
  
  function start_stop_attributes($aAttributes) {
    $aArgs = func_get_args();
    //LEGACY support for start, end 
    if (empty($aArgs[2]->aCurArgs['playlist'])) {
      if (isset($aArgs[2]->aCurArgs['start']) && strlen(trim($aArgs[2]->aCurArgs['start']))) {
        $aAttributes['data-start'] = trim($aArgs[2]->aCurArgs['start']);
      }
      if (isset($aArgs[2]->aCurArgs['end']) && strlen(trim($aArgs[2]->aCurArgs['end']))) {
        $aAttributes['data-end'] = trim($aArgs[2]->aCurArgs['end']);
        if (empty($aArgs[2]->aCurArgs['start'])) {
          $aAttributes['data-start'] = 0;
        }
      }
    }
    // END LEGACY
    if (isset($aArgs[2]->aCurArgs['startend'])) {
      $aTmp = explode(';', $aArgs[2]->aCurArgs['startend'], 2);
      $aStartEnd = explode('-', $aTmp[0], 2);
      $aAttributes['data-start'] = $aStartEnd[0];
      $aAttributes['data-end'] = isset($aStartEnd[1]) ? $aStartEnd[1] : '';
    }
    return $aAttributes;
  }

  public function copy_text_attributes($aAttributes) {
    $aArgs = func_get_args();
    if (
            $this->_get_option( array('pro','copy_text') ) && (!isset($aArgs[2]->aCurArgs['copy_text']) || $aArgs[2]->aCurArgs['copy_text'] !== 'true' ) ||
            isset($aArgs[2]->aCurArgs['copy_text']) && $aArgs[2]->aCurArgs['copy_text'] === 'true'
    ) {
      $user_data = wp_get_current_user();
      $aAttributes['data-user'] = json_encode(array(
          'id' => isset($user_data->ID) ? $user_data->ID : 'none',
          'username' => isset($user_data->user_login) ? $user_data->user_login : 'none',
          'IP' => $_SERVER['REMOTE_ADDR'],
          'date' => date('F j, Y'),
          'site' => preg_replace( '~.*?//~', '', home_url() )
      ));
    }
    return $aAttributes;
  }

  function strip_rtmp_ext( $rtmp ) {
    return preg_replace( '~^(mp4|flv):~', '', $rtmp );
  }
  
  
  
  
  function video_ads( $aItems ) {
    global $fv_fp, $fv_wp_flowplayer_ver;
		
    $this->bVideoAdsStatus = array();

    $aArgs = func_get_args();
    if (!isset($aArgs[1]->hash)) {
      return $aItems;
    }

    if (!$this->_get_option( array('pro','video_ads') )) {
      return $aItems;
    }
    
    if (isset($aArgs[1]->aCurArgs['lightbox']) && strpos($aArgs[1]->aCurArgs['lightbox'], 'true') !== false && ( version_compare( $fv_wp_flowplayer_ver, '6.0.5.5.9' ) == - 1 || isset($aArgs[1]->aCurArgs['playlist']) && $aArgs[1]->aCurArgs['playlist'] ) ) {
      return $aItems;
    }

    $aVideoAds = $this->_get_option( array('pro','video_ads') );
    $aVideoAdsEnabled = array();
    foreach ($aVideoAds AS $k => $i) {
      if ($i['disabled'] == 0 && trim( $i['videos']['mp4'] ) !== '' ) {
        $aVideoAdsEnabled[] = $i;
      }
    }
    
    if (count($aVideoAdsEnabled) == 0) {
      return $aItems;
    }
        
    $this->aVideoAds["wpfp_" . $aArgs[1]->hash] = array();
    
    $aCvaIds = array( 0 => isset($aArgs[1]->aCurArgs['preroll']) ?  $aArgs[1]->aCurArgs['preroll']  : '', 
                1 => isset($aArgs[1]->aCurArgs['postroll']) ? $aArgs[1]->aCurArgs['postroll'] : '' );
    foreach ($aCvaIds as $iPosition => $cva_id) {
      
      $cva_id = trim($cva_id);
      
      if ($cva_id == "default" || empty($cva_id)) {
        if( $iPosition && $this->_get_option( array('pro','video_ads_postroll_default') ) ) {
          $cva_id = $this->_get_option( array('pro','video_ads_postroll_default') );
        } else if( $this->_get_option( array('pro','video_ads_default') ) ) {
          $cva_id = $this->_get_option( array('pro','video_ads_default') );
        }
      }
      
      if ($cva_id == "no" ) {
        continue;
      }
      
      if ($cva_id == "random") {
        $cva_id = rand(0, count($aVideoAdsEnabled) - 1);
        $aVideoAd = $aVideoAdsEnabled[$cva_id];
        
      } else {
        $cva_id = $cva_id - 1;
        if (!isset($aVideoAds[$cva_id]) || $aVideoAds[$cva_id]['disabled'] === 1 || trim( $aVideoAds[$cva_id]['videos']['mp4'] ) === '' ) {
          continue;
        }
        $aVideoAd = $aVideoAds[$cva_id];
      }

      $aVideoObj = array('sources' => array());
      foreach ($aVideoAd['videos'] AS $key => $value) {
        if (/* $key == 'rtmp' || ( strlen($aVideoAd['videos']['rtmp']) && $key == 'flash' ) || */!strlen(trim($value)))
          continue;

        $aVideoObj['sources'][] = array('src' => $value, 'type' => $fv_fp->get_mime_type($value), 'fv_title' => trim($aVideoAd['name']) == '' ? '' : ('Video Ad:' . trim($aVideoAd['name'])));
      }

      if ($iPosition == 0 ) {
        $aItems = array_merge(array($aVideoObj), $aItems);

        $this->aVideoAds["wpfp_" . $aArgs[1]->hash][0] = $aVideoAd['click'];
        $this->bVideoAdsStatus['preroll'] = $aVideoObj;
        $this->bDynamic = true;
      }elseif ($iPosition == 1) {
        $aItems = array_merge($aItems, array($aVideoObj));

        $this->aVideoAds["wpfp_" . $aArgs[1]->hash][count($aItems) - 1] = $aVideoAd['click'];
        $this->bVideoAdsStatus['postroll'] = $aVideoObj;
        $this->bDynamic = true;
      }
    }
    return $aItems;
  }
  
  
  
  function video_ads_item_html( $aHTML ) {
    
    if( ( isset($this->bVideoAdsStatus['preroll']) || isset($this->bVideoAdsStatus['postroll']) ) && count($aHTML) == 1 ) {
      $aHTML[0] = str_replace( "<a ", "<a style='display: none' ", $aHTML[0] );
    }

    if( isset($this->bVideoAdsStatus['preroll']) ) {
      $aHTML = array_merge( array("\t\t<a href='' data-item='".json_encode($this->bVideoAdsStatus['preroll'])."' style='display: none'></a>\n"), $aHTML );
    }

    if( isset($this->bVideoAdsStatus['postroll']) ) {
      $aHTML = array_merge( $aHTML, array("\t\t<a href='' data-item='".json_encode($this->bVideoAdsStatus['postroll'])."' style='display: none'></a>\n") );
    }    
   
    return $aHTML;
  }
  
  
  
  
  function youtube_duration( $iTime ) {
    return $iTime;
    
    $aArgs = func_get_args();
    
    if( $iTime == 0 && $aId = $this->is_youtube($aArgs[1]) ) {
      $response = wp_remote_get( 'http://gdata.youtube.com/feeds/api/videos/'.$aId[1].'?v=2&alt=jsonc', array( 'sslverify' => false ) );        
      $obj = is_wp_error($response) ? false : @json_decode( wp_remote_retrieve_body($response) );

      if( $obj && isset($obj->data->duration) ) {
        $iTime = $obj->data->duration;
      }
      
    }

    return $iTime;
  }
  
  
  
  
  function get__cached_splash( $splash ) {
    global $post, $fv_fp;
    $aArgs = func_get_args();

    if( !$splash ) {
      $src = isset($aArgs[2]) && isset($aArgs[2][0]) ? $aArgs[2][0] : $fv_fp->aCurArgs['src'];

      $sVideoMeta = isset($post) ? get_post_meta( $post->ID, flowplayer::get_video_key($src, true ), true ) : false;
      if( isset($sVideoMeta['splash']) ) {
        return $sVideoMeta['splash'];
      }
      
      if( $this->fTimeSpent_AutoSplash < 1 ) {
        global $post;
        if( $video_id = $this->is_youtube($src) ) {
          $video_id = $video_id[1];
          $type = 'youtube';
        } else {
          $video_id = $this->func__get_vimeo_id($src);  //  returns false if not Vimeo
          $type = 'vimeo';
        }

        if( $video_id && !isset($post) || !isset($post->post_content) || stripos($post->post_content,$src) === false ) {  //  only do this if the YouTube video is not part of post content
          $tStart = microtime(true);
          $splash = get_option('fv_player_'.$type.'_splash_'.$video_id);
          if( !$splash ) {
            $videoData = $this->fetch_vimeo_yt_data($src);
            if( $videoData && isset($videoData['thumbnail']) ) {
              $this->fTimeSpent_AutoSplash += microtime(true) - $tStart;
              update_option('fv_player_'.$type.'_splash_'.$video_id, $videoData['thumbnail'] );
              return $videoData['thumbnail'];
            }

          } else {
            return $splash;

          }
          
        }
      }
    }
    
    return $splash;    
  }
  

  
  
  function vimeo_channel( $attrs ) {
    $aArgs = func_get_args();
    
    if( !isset($aArgs[2]) || !isset($aArgs[2]['channel']) ) {
      return $attrs;
    }
            
    $sChannel = trim($aArgs[2]['channel']);
    if( stripos($sChannel,'vimeo.com/') ) {
      $sChannel = preg_replace( '~.*?([^/]+)/?$~', '$1', $sChannel );
    } else {
      return $attrs;
    }

    $objCache = get_option( $this->get__transient_name('vimeo_channel').$sChannel );

    if( $objCache && isset($objCache->date) && $objCache->date + 900 > time() ) {
      if( in_the_loop() && $this->is_option_enabled('vimeo_debug') ) {
        echo "<!-- FV Player Pro - Vimeo Channel $sChannel from cache ".$objCache->date."-->\n";
      }
    } else {
      $sResponse = $this->func__http( array( 'action' => 'v_channel', 'item_id' => $sChannel ) );//var_dump($sResponse);die();
      $sResponse = preg_replace( '~^.*<FVSERVICES>(.*?)</FVSERVICES>.*$~', '$1', $sResponse );
      $objCacheNew = json_decode($sResponse);
      
      if( isset($objCacheNew->shortcode) ) {
        $objCache = $objCacheNew;
        
        $objCache->date = time();
        
        if( in_the_loop() && $this->is_option_enabled('vimeo_debug') ) {
          echo "<!-- FV Player Pro - Vimeo Channel $sChannel cached ".$objCache->date."-->\n";
        }
        
      } else {
        if( in_the_loop() && $this->is_option_enabled('vimeo_debug') ) {
          echo "<!-- FV Player Pro - Vimeo Channel $sChannel from cache ".$objCache->date." although it's old! -->\n";
        }
        $objCache->date = time() - 600;
        
      }
      
      update_option( $this->get__transient_name('vimeo_channel').$sChannel, $objCache, false );
    }
      
    if( isset($objCache->shortcode) ) {
      $attrs = wp_parse_args( $objCache->shortcode, $attrs );
    }
    
    return $attrs;
  }
  
  
  
  
  function vimeo_key_check_note() {
    if( !$this->get__vimeo_key() ) {
      return;
    }
    
    $result = $this->vimeo_key_check_cache();
    if( !empty($result['error']) ) : ?>
      <div class="error">
        <p><?php _e('FV Player Pro: Your Vimeo access token appears to be invalid', 'fv-player-pro'); ?>: '<?php echo $result['error']; ?>' (<a href="<?php echo site_url('wp-admin/options-general.php?page=fvplayer#fv_player_pro_vimeo'); ?>"><?php _e('settings', 'fv-player-pro'); ?></a>)</p>
      </div>
    <?php endif;
  }
  
  
  
  
  function vimeo_key_check_cache() {
    if( !$this->get__vimeo_key() ) {
      return false;
    }
    
    $aCache = get_option('fv_player_pro_vimeo_check');
    if( $aCache && !empty($aCache['time']) && $aCache['time'] + 6 * 3600 > time() ) {
      $result = $aCache;
      
    } else {
      $result = array();
      $result['time'] = time() - 6 * 3600 + 900;
      
      try {
        require_once( dirname(__FILE__).'/includes/vimeo.php');
        $hVimeo = new FVVimeo( false, false, $this->get__vimeo_key() );
        $result = $hVimeo->request('/me');
        if( isset($result['body']) ) {
          $result = $result['body'];
          $result['time'] = time();
        } else {
          $result['error'] = 'Vimeo key check failed';
        }
        
      } catch( Exception $e ) {
        $result['error'] = 'Vimeo key check failed: '.$e->getMessage();
      }
      
      update_option( 'fv_player_pro_vimeo_check', $result );
      
    }
    
    return $result;
  }  
  
  
  
  
  function vimeo_mpd_htaccess() {
    $sDashFolder = WP_CONTENT_DIR . '/cache/fv-player-mpd/'.get_current_blog_id() . '/';
    $aURL = parse_url(home_url());
    if( $this->_get_option( array('pro','vimeo_security') ) ) {
      if( !file_exists($sDashFolder.'.htaccess') || // if the file doesn't exist
        !empty($aURL['host']) && stripos(file_get_contents( $sDashFolder.'.htaccess'), '!'.$aURL['host'].' [NC]') === false ) { // or it doesn't match
        if( !empty($aURL['host']) ) {
          $sHtaccessRules = "RewriteEngine On
    RewriteCond %{HTTP_REFERER} !".$aURL['host']." [NC]
    RewriteRule ^ - [F]";          
          file_put_contents( $sDashFolder.'.htaccess', $sHtaccessRules );
        }
      }
      
    } else if( file_exists($sDashFolder.'.htaccess') ){
      unlink( $sDashFolder.'.htaccess' );
    }         
  }
  
  
  
  
  function youtube_channel( $attrs ) {
    $aArgs = func_get_args();
    
    if( !isset($aArgs[2]) || ( !isset($aArgs[2]['src']) && !isset($aArgs[2]['channel']) ) ) {
      return $attrs;
    }
            
    if( !empty($aArgs[2]['channel']) ) {
      $sChannelURL = trim($aArgs[2]['channel']);
      if( ( stripos($sChannelURL,'youtube.com/') === false && stripos($sChannelURL,'youtu.be/') === false ) || stripos($sChannelURL,'/channel/') === false ) {
        return $attrs;
      }
      
      preg_match( '~/channel/([a-zA-Z0-9-_]*+)~', $sChannelURL, $aListID );
      if( !$aListID ) {
        return $attrs;
      }      
      
            
    } else {
      $sPlaylistURL = trim($aArgs[2]['src']);
      if( ( stripos($sPlaylistURL,'youtube.com/') === false && stripos($sPlaylistURL,'youtu.be/') === false ) || stripos($sPlaylistURL,'list=') === false ) {
        return $attrs;
      }
      
      if( stripos($sPlaylistURL,'watch') !== false ) {
        return $attrs;
      }
      
      preg_match( '~list=([a-zA-Z0-9-_]*+)~', $sPlaylistURL, $aListID );
      if( !$aListID ) {
        return $attrs;
      }      
        
    }
    
    $sYouTubeKey = $this->_get_option( array('pro','youtube_key') );
    if( !$sYouTubeKey  ) {
      $this->aFrontendErrors[] = '<strong>Error:</strong> Google Developer Key required.';
      return array();
    }

    $sListID = $aListID[1];
    
    $sPrefix = !empty($aArgs[2]['channel']) ? 'fv_player_pro_youtube_channel_' : 'fv_player_pro_youtube_playlist_';
    $sMessage = !empty($aArgs[2]['channel']) ? 'YouTube Channel' : 'YouTube Playlist';

    $objCache = get_option( $sPrefix.$sListID );
    
    $aCaption = array();
    $aPlaylist = array();

    if( $objCache && isset($objCache->date) && $objCache->date + 900 > time() ) {
      if( in_the_loop() && $this->is_option_enabled('vimeo_debug') ) {
        echo "<!-- FV Player Pro - $sMessage $sListID from cache ".$objCache->date."-->\n";
      }
    } else {
      if( !empty($aArgs[2]['channel']) ) {
        $aResponse = wp_remote_get( 'https://www.googleapis.com/youtube/v3/search?key=' . $sYouTubeKey . '&channelId='.$sListID.'&part=snippet,id&order=date&maxResults=50&type=video&order=date' );
        var_dump('https://www.googleapis.com/youtube/v3/search?key=' . $sYouTubeKey . '&channelId='.$sListID.'&part=snippet,id&order=date&maxResults=50',$aResponse);die(); //  todo: what? no videos!
      } else {
        $aResponse = wp_remote_get( 'https://www.googleapis.com/youtube/v3/playlistItems?part=snippet&maxResults=50&playlistId='.$sListID.'&key=' . $sYouTubeKey );
      }
      
      if( is_wp_error($aResponse) ) {
        $this->aFrontendErrors[] = '<strong>Error:</strong> YouTube API call failed.';
        return $attrs;
      }
            
      $objCacheNew = json_decode($aResponse['body']);      
            
      if( count((array)$objCacheNew->items) ) {
        $objCache = $objCacheNew;
        
        $objCache->date = time();
        
        if( in_the_loop() && $this->is_option_enabled('vimeo_debug') ) {
          echo "<!-- FV Player Pro - $sMessage $sListID cached ".$objCache->date."-->\n";
        }
        
      } else {
        if( in_the_loop() && $this->is_option_enabled('vimeo_debug') ) {
          echo "<!-- FV Player Pro - $sMessage $sListID from cache ".$objCache->date." although it's old! -->\n";
        }
        $objCache->date = time() - 600;
        
      }
      
      update_option( $sPrefix.$sListID, $objCache );
    }
      
    $iCount = 0;
    foreach( (array) $objCache->items AS $aItem ) {
      if( empty($aItem->snippet->resourceId->videoId) ) {
        continue;
      }
      
      if( $iCount == 0 ) {
        $attrs['src'] = 'https://www.youtube.com/watch?v='.$aItem->snippet->resourceId->videoId;
        $attrs['splash'] = $aItem->snippet->thumbnails->standard->url;
      } else {
        $aPlaylist[] = 'https://www.youtube.com/watch?v='.$aItem->snippet->resourceId->videoId.','.$aItem->snippet->thumbnails->medium->url;
      }
      $aCaption[] = str_replace( ';', ',', $aItem->snippet->title );
      $iCount++;
      
    }
    
    if( count($aPlaylist) ) {
      $attrs['playlist'] = implode(';',$aPlaylist);
      if( !empty($attrs['caption']) ) {
        $attrs['caption'] = implode(';',$aCaption);
      }
    }

    return $attrs;
  }  
  
  
  
  
  function youtube_splash( $splash ) {
    $aArgs = func_get_args();
    
    if( !$splash ) {
      global $fv_fp;
      if( isset($aArgs[2]) && isset($aArgs[2][0]) && $res = $this->is_youtube($aArgs[2][0]) ) { //  playlist items
        return "https://img.youtube.com/vi/".$res[1]."/mqdefault.jpg#auto";
      } else if( !isset($aArgs[2]) && !isset($aArgs[2][0]) && $res = $this->is_youtube($fv_fp->aCurArgs['src']) ) { //  single video
        return "https://img.youtube.com/vi/".$res[1]."/maxresdefault.jpg#auto";
      }
    } else if( stripos($splash,'maxresdefault.jpg') !== false && stripos($splash,'img.youtube.') !== false ) {      
      return str_replace( 'maxresdefault.jpg','mqdefault.jpg#auto', $splash );
    }
    return $splash;
  }
  
  function  secure_hls_attributes( $aAttributes ) {
    global $fv_fp;

    if(isset($fv_fp->aCurArgs['hlskey'])){
      $aAttributes['data-fvhkey'] = 'true';
    }
    
    return $aAttributes;
  }
  
  function secure_hls_stop_autoplay( $aArgs ) {
    if( !empty($aArgs['hlskey']) ) {
      $aArgs['autoplay'] = 'false';
    }
    return $aArgs;
  }
  
  function ajax__get_secure_hls_cookie(){

    global $wpdb;
    $sUrl = sanitize_title($_POST['url']);
    if( !$wpdb->insert($wpdb->prefix.'fv_fp_hls_access_tokens',array('url'=>$sUrl,'client'=>$_SERVER['REMOTE_ADDR'],'cookie' => '')) ) {  //  wpdb::strip_invalid_text() bug, see ticket 85672724
      $wpdb->query("INSERT INTO `{$wpdb->prefix}fv_fp_hls_access_tokens` (`url`, `client`, `cookie`) VALUES ('".esc_sql($sUrl)."', '".esc_sql($_SERVER['REMOTE_ADDR'])."', '')");
    }
    die;
  }
  
  function secure_hls_key_send() {
    if (!isset($_GET['fv_player_hls_key'])) {
      return;
    }
    
    @header("Expires: 0");
    @header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    @header("Cache-Control: no-store, no-cache, must-revalidate");
    @header("Cache-Control: post-check=0, pre-check=0", false);
    @header("Pragma: no-cache");    

    global $wpdb;
    $key = $_GET['fv_player_hls_key'];  //  video-cdn.com/{mystream}/index.m3u8
    $authorized = false;

    for ($try = 0; $try < 20; $try++) {
      $sUrl = sanitize_title($key);
      $sSql = "SELECT * FROM `{$wpdb->prefix}fv_fp_hls_access_tokens` WHERE `client` LIKE '{$_SERVER['REMOTE_ADDR']}' AND `time` > DATE_SUB(NOW(),INTERVAL 30 SECOND) AND `url` LIKE '%$sUrl%' ORDER BY ID DESC";
      $aResults = $wpdb->get_results($sSql, ARRAY_A);
      if( empty($aResults) ) {
        $sUrl = sanitize_title(str_replace(' ', '+', $key));
        $sSql = "SELECT * FROM `{$wpdb->prefix}fv_fp_hls_access_tokens` WHERE `client` LIKE '{$_SERVER['REMOTE_ADDR']}' AND `time` > DATE_SUB(NOW(),INTERVAL 30 SECOND) AND `url` LIKE '%$sUrl%' ORDER BY ID DESC";
        $aResults = $wpdb->get_results($sSql, ARRAY_A);
      }
      if (!empty($aResults)||$authorized) {
        $wpdb->query("DELETE FROM `{$wpdb->prefix}fv_fp_hls_access_tokens` WHERE `id` = ".$aResults[0]['id']);
        $authorized = true;
        break;
      }   
      $wpdb->query("DELETE FROM `{$wpdb->prefix}fv_fp_hls_access_tokens` WHERE `time` <= DATE_SUB( NOW(),INTERVAL 30 SECOND ) ");
      usleep(250000);
    } 

    if (!$authorized) {
      die();
    }

    $aKeys = array( $key.'/', $key.'.m3u8' );
    if( stripos($key,' ') !== false ) {
      $new_key = str_replace( ' ', '+', $key );
      $aKeys[] = $new_key.'/';
      $aKeys[] = $new_key.'.m3u8';
    }
    
    foreach( $aKeys AS $try_key ) {  // has to be either the m3u8 directory or the directory and full filename

      $aAllPosts = $wpdb->get_results("SELECT `post_content`, ID FROM `" . $wpdb->posts . "` WHERE `post_status` NOT IN ('trash', 'auto-draft', 'inherit') AND `post_content` LIKE '%" . esc_sql($try_key) . "%' ORDER BY post_modified DESC");
      if (!empty($aAllPosts)) {
        foreach ($aAllPosts as $aOnePost) {
          $sOnePost = $aOnePost->post_content;
          $aMatches = array();
          $aMatches2 = array();
          //  OptimizePress seems to render the shortcode HTML into the post content, so then the shortcode can't be matched. But it's still found in some textarea where it's encoded, so we also try urldecode()
          $try_key = preg_quote($try_key,'~');
          if( preg_match('~\[fvplayer[^\]]*' . $try_key . '[^\]]*\]~i', $sOnePost, $aMatches) || preg_match('~\[fvplayer[^\]]*' . $try_key . '[^\]]*\]~i', urldecode($sOnePost), $aMatches) ) {
            if( ( preg_match('/(?:hlskey=")([^"]*)(?:")/', $aMatches[0], $aMatches2) || preg_match('/(?:hlskey=")([^"]*)(?:")/', html_entity_decode($aMatches[0]), $aMatches2) ) && strlen($aMatches2[1]) == 24 ) {
              header('Content-Type: binary/octet-stream');
              header('Pragma: no-cache');
              die(base64_decode($aMatches2[1]));
            }
          }
        }
      } 

    }


  }
  
  function ajax__get_decrypt_hlskey() {
    global $fv_fp;

    if(version_compare(phpversion(),'5.5.0','<')){
      die('php must be > 5.5.0');
    } 
    if (empty($_POST['cryptic']) || strlen($_POST['cryptic']) < 150) {
      die('cryptic');
    }
    if(!$this->_get_option( array('pro','elastic_key') )||!$this->_get_option( array('pro','elastic_region') )||!$this->_get_option( array('pro','elastic_region') )){
      die('settings');
    }
    $result = false;
    if(!class_exists('\Aws\Kms\KmsClient')){
      require dirname(__FILE__) . '/includes/aws/aws-autoloader.php';
    }
    //php5.2 compatibility - calls inside cause PHP parse error on 5.2
    require dirname(__FILE__) . '/fv-aws-function.php';



    die(base64_encode($result->get('Plaintext')));

  }
  
  
  public function clear_cache( $force = false ) {
    
    global $wpdb;
    $aOptions = $wpdb->get_col( "SELECT option_name FROM $wpdb->options WHERE option_name LIKE '%fv_player_pro_vimeo_%'" );
    if( $aOptions ) {
      foreach( $aOptions AS $option ) {
        delete_option($option); //  exp: clears Vimeo cache including the key check
      }
    }

    $pathMatch = array();
    if (!preg_match('/^.*wp-content\//', __FILE__, $pathMatch)) {
      return;
    }
    $blog_id = $this->_get_option( array('pro','vimeo_direct_ajax') ) ? 1 : get_current_blog_id();
    
    $files = array();
    $cacheDirMpd = $pathMatch[0] . "cache/fv-player-mpd/$blog_id/";
    if( file_exists($cacheDirMpd) ) {
      foreach( scandir($cacheDirMpd) AS $file ) $files[] = $cacheDirMpd . $file;
    }
    $cacheDirVimeo = $pathMatch[0] . "cache/fv-player-vimeo/";
    if( file_exists($cacheDirVimeo) ) {
      foreach( scandir($cacheDirVimeo) AS $file ) $files[] = $cacheDirVimeo . $file;
    }
      
    if( count($files) ) {
      foreach ($files as $file) {
        if (is_file($file)) {
          if ( $force && time() - filemtime($file) >= 60 * 60 * 24) {
            unlink($file);
          }
        }
      }
    }
  }

  public function cron_init() {
    if ( !wp_next_scheduled( 'fv_player_pro_clear_cache' ) ) {
      wp_schedule_event( time(), 'daily', 'fv_player_pro_clear_cache' );
    }
  }
  
  function use_old_code() {
    global $fv_wp_flowplayer_ver;
    if( version_compare($fv_wp_flowplayer_ver,'6.0.5.25') == -1 || $this->_get_option('old_code') ) return true;
    
    return false;
  }
  
}


global $FV_Player_Pro;
$FV_Player_Pro = new FV_Player_Pro;

endif;
