<?php
//if( !isset($_POST['action']) || $_POST['action'] != 'fv_fp_get_vimeo' ) die ('¯\_(ツ)_/¯');

global $cacheDirMpd;
global $pathMatch;
global $mpd;

global $iLoadingRecursion, $pregDirSeparator;
$iLoadingRecursion = 0;
$pregDirSeparator = DIRECTORY_SEPARATOR;

// escape directory separator for regex calls
if ($pregDirSeparator == '\\') {
  $pregDirSeparator = '\\\\';
} else if ($pregDirSeparator == '/') {
  $pregDirSeparator = '\/';
}

if(!preg_match('/^.*wp-content'.$pregDirSeparator.'/', __FILE__, $pathMatch )){
  die;
}
$cacheDir = $pathMatch[0] . 'cache'.DIRECTORY_SEPARATOR.'fv-player-vimeo'.DIRECTORY_SEPARATOR;
$cacheDirMpd = $pathMatch[0] . 'cache'.DIRECTORY_SEPARATOR.'fv-player-mpd'.DIRECTORY_SEPARATOR.'1'.DIRECTORY_SEPARATOR;

if(!file_exists($cacheDir)){
  mkdir($cacheDir,0755,true);
}
if(!file_exists($cacheDir)){
  die;
}
ajax__get_vimeo();



//create cache folder

function ajax__get_vimeo() {    
  @header( 'Content-Type: application/json; charset=UTF-8' );
  $aData = func__get_vimeo( $_POST['sources'][0]['src'] );
  echo '<FVFLOWPLAYER>';
  if( is_object($aData) ) {
    echo json_encode( $aData );
  } else {
    echo json_encode( array( 'error' => 'Unknown error' ) );
  }
  echo '</FVFLOWPLAYER>';
 
  die();
}


function func__get_vimeo( $video_url ) {
  
  $mpd = !empty($_POST['v_dash']) && $_POST['v_dash'] == 1;

  if( !$video_id = func__get_vimeo_id($video_url) ) {
    return (object)array( 'error' => 'Bad video ID!' );
  }        

  $bFound = false;
  $objVideo = get_cache_file( 'fv_player_pro_vimeo_' . $video_id );  
  if( $objVideo && isset($objVideo->time) && isset($objVideo->ttl) && (intval($objVideo->time) + intval($objVideo->ttl)) > time() ) {
    $objVideo->cache = true;      
    $objVideo->time_now = time();
    $bFound = true;
   // if( isset($objVideo->id) ) $sResponse = func__http( array( 'action' => 'v_ping', 'item_id' => intval($objVideo->id), 'async' => true ) );
  }
  if( !$bFound ) {
  
    $sResponse = func__http( array( 'action' => $mpd ? 'v_grab_dash' : 'v_grab', 'item_id' => intval($video_id) ) );
    if( stripos($sResponse,'privacy settings') !== false ) {
      $objVideo = new stdClass;
      $objVideo->error = 'Video can\'t be played because of its privacy settings. Please allow you site domain to embed the video in its settings.';
      $iTTL = 30;
    } else {
      $aResponse = explode( '<FVSERVICES>', $sResponse );        
      $objVideo = false;
      if( isset($aResponse[1]) ) {
        $aResponse = explode( '</FVSERVICES>', $aResponse[1] );
        $objVideo = json_decode($aResponse[0]);
        $iTTL = 120;
      }

      if( $objVideo == NULL ) {
        $objVideo = new stdClass;
        $objVideo->error = $sResponse;
        $iTTL = 30;
      }

    }
    $objVideo->time = ( isset($objVideo->time) && intval($objVideo->time) > 0 ) ? $objVideo->time : time();
    $objVideo->ttl = ( isset($objVideo->ttl) && intval($objVideo->ttl) > 0 ) ? $objVideo->ttl : $iTTL;
    if( $objVideo->ttl > 1200 ) $objVideo->ttl  = 1200;

  }

  $time = $objVideo->time;
  global $cacheDirMpd;
  $sDashFolder = $cacheDirMpd ;
  $sDashFile = 'manifest-'.$video_id.'-'.$time.'.mpd';
  $sDashPath = $sDashFolder . $sDashFile;
  

  if( !$bFound || !file_exists($sDashPath) ) {
    if( isset($objVideo->mpd) && $objVideo->mpd && isset($objVideo->mpd->xml) && isset($objVideo->mpd->init_segments) && $mpd ){

      
      if( !file_exists($sDashFolder) ) {
        mkdir($sDashFolder,0755,true);
      }
      if(!file_exists($sDashFolder)){
        die();
      }

      $base_path = dirname(__FILE__);;
     

      $base_url =  str_replace( array('/plugins','\\plugins'), '', str_replace( array('http://','https://'),'//', plugins_url()) ) . 'fv-player-mpd/1/';
      //file_put_contents( ABSPATH.'mpd.log', date('r').":\n".var_export($objVideo->mpd,true)."\n\n", FILE_APPEND );

      $objVideo->mpd->xml = str_replace(array('%mpd_url%','%mpd_time%'),array($base_url,$time),$objVideo->mpd->xml);
      $objVideo->request->files->dash->url = $base_url.$sDashFile;
      file_put_contents( $sDashPath, $objVideo->mpd->xml );     
      unset($objVideo->mpd->xml);

      foreach($objVideo->mpd->init_segments as $key => $segment){        
        file_put_contents( $sDashFolder . 'init-'.$video_id.'-'.$time.'-'.$key.'.mp4', base64_decode($segment));
        unset($objVideo->mpd->xml);
      }

      if(isset($objVideo->mpd->audio_segments)){
        foreach($objVideo->mpd->audio_segments as $key => $segment){
          file_put_contents( $sDashFolder . 'init-'.$video_id.'-'.$time.'-'.$key.'.m4s', base64_decode($segment));
          unset($objVideo->mpd->xml);
        }
      }

    } else if (is_object($objVideo) && isset($objVideo->request) && is_object($objVideo->request) && isset($objVideo->request->files) && is_object($objVideo->request->files) ) {
      unset($objVideo->request->files->dash);

    }
    
    
    if( isset($objVideo->mpd_backup) && $objVideo->mpd_backup && isset($objVideo->mpd_backup->xml) && isset($objVideo->mpd_backup->init_segments) && $mpd ){
        
        if( !file_exists($sDashFolder) ) {
          mkdir($sDashFolder,0755,true);
        }
        
        $sDashFile = 'manifest-'.$video_id.'-backup-'.$time.'.mpd';
        $sDashPath = $sDashFolder . $sDashFile;
        
        $base_url = str_replace( array('/plugins','\\plugins'), '', str_replace( array('http://','https://'),'//', plugins_url()) ) . 'fv-player-mpd/1/';
        
        //file_put_contents( ABSPATH.'mpd.log', date('r').":\n".var_export($objVideo->mpd_backup,true)."\n\n", FILE_APPEND );
        
        $objVideo->mpd_backup->xml = str_replace(array('%mpd_url%','%mpd_time%'),array($base_url,$time),$objVideo->mpd_backup->xml);
        $objVideo->request->files->dash->url_backup = $base_url.$sDashFile;
        file_put_contents( $sDashPath, $objVideo->mpd_backup->xml );     
        //unset($objVideo->mpd_backup->xml);
        
      }
  }

  if( !$bFound ) {
    if(!set_cache_file( 'fv_player_pro_vimeo_'.$video_id, $objVideo, $video_id )){
      $objVideo = array( 'error' => 'Server cache Error' );
    }
  }

  return $objVideo;
}

function func__get_vimeo_id( $video_url ) {
  if( preg_match( "~vimeo.com/(?:video/|moogaloop\.swf\?clip_id=)?(\d+)~i", $video_url, $video_id ) ) {
    return $video_id[1];
  } else {
    return false;
  }
}

function func__http( $aArgs ) {
  $aPOST = array_merge( $aArgs,
                array(
                  'version' => '6.6.3.turbocharged',
                  'site' => $_SERVER['HTTP_HOST'],
                  'key' => 'turbocharged',
                  'vimeo_at' => get_vimeo_access_token(),
                )
              );
  
 

  $sPOST = '';
  foreach( $aPOST as $key=>$value) {
    $sPOST .= $key.'='.$value.'&';
  }
  rtrim( $sPOST, '&' );
  

  //  first we check the stored scores for each API
  $aServers = array( 'api' => 0, 'api-eu' => 0, 'api-sg' => 0 );
  $aServersCache = get_cache_file( 'fv_player_pro_api' );
  if( !$aServersCache ) $aServersCache = array();
  
  // admin setting for server selected by default
  $defaultServer = $_POST['default_api_server'];

  // if there is no _time key in servers list, add it there,
  // since this is our first clean run without any cache
  if (!isset($aServersCache['_time'])) {
    $aServersCache['_time'] = time();
  }

  // only check once every 24 hours or 1 hour if we have a preferred server
  $cacheClearTime = $aServersCache['_time'] + 24 * 3600;
  if ($defaultServer) {
    $cacheClearTime = $aServersCache['_time'] + 3600;
  }

  if( isset($aServersCache['_time']) && $cacheClearTime < time() ) {
    $aServersCache = array();
  }
  
  $aServers = array_merge( $aServers, $aServersCache );
  $bTest = in_array(0,$aServers) ? true : false;
  $noPredefinedServer = ($defaultServer ? false : true);

  $iServersAvailable = 0;
  
  $iMin = 9999;

  // if the default server is not set, set it to API
  if (!$defaultServer) {
    $defaultServer = 'api';
  }

  $sWinner = $defaultServer;
  $defaultServerAvailable = false;
  foreach( $aServers AS $sAPI => $sScore ) {
    if( $sAPI == '_time' ) continue;
    
    if( $iMin > $sScore ) {
      $sWinner = $sAPI;
      $iMin = $sScore;
    }
    
    if( $sScore < 9999 ) {
      $iServersAvailable++; //  we need to know how many servers are left for retry

      // if default server is usable, use it
      if ($sAPI === $defaultServer && !$noPredefinedServer) {
        $defaultServerAvailable = true;
  }
    }
  }
  
  if ($defaultServerAvailable && $sWinner !== $defaultServer) {
    $sWinner = $defaultServer;
  }
  //

  if( isset($aArgs['async']) ) {
    $pSocket = @fsockopen( $sWinner.".foliovision.com", 443, $errno, $errstr, 10 );
    if( $pSocket ) {
      $strOut =  "POST / HTTP/1.1\r\n";
      $strOut .= "Host: ".$sWinner.".foliovision.com\r\n";
      $strOut .= "Content-Type: application/x-www-form-urlencoded\r\n";
      $strOut .= "Content-Length: ".strlen( $sPOST )."\r\n";
      $strOut .= "Connection: Close\r\n\r\n";
      $strOut .= $sPOST;
      
      fwrite( $pSocket, $strOut );
      fclose( $pSocket );
    }
    return null;
  
  } else {
    $tStart = microtime(true);
    $hCurl = curl_init("https://".$sWinner.".foliovision.com/");
    curl_setopt($hCurl, CURLOPT_RETURNTRANSFER, true);
    //curl_setopt($hCurl, CURLOPT_SSL_VERIFYPEER, false);
    //curl_setopt($hCurl, CURLOPT_SSL_VERIFYHOST, 2);
    curl_setopt($hCurl, CURLOPT_CONNECTTIMEOUT, 5);
    curl_setopt($hCurl, CURLOPT_TIMEOUT, 10);
    curl_setopt($hCurl, CURLOPT_POSTFIELDS, $sPOST);
    $response = curl_exec($hCurl);
    
    
    //  store what you measured, but only if it's testing phase or there was an error!
    $tDuration = curl_errno( $hCurl ) ? 9999 : ceil( ( microtime( true ) - $tStart ) * 1000 );
    
    //file_put_contents( 'fv-api-turbo.log', date('r').": ".$sWinner." (".$tDuration.") ".$bTest."\n", FILE_APPEND );
    
    global $iLoadingRecursion;
    $aServers[$sWinner] = $tDuration;
    $aServers['_time'] = time();
    if( $bTest || curl_errno($hCurl) ) {
      set_cache_file( 'fv_player_pro_api', $aServers );      
    }
    //    
        
    if(curl_errno($hCurl)){      
      $iLoadingRecursion++;
      if( $iLoadingRecursion > $iServersAvailable ) {
        set_cache_file( 'fv_player_pro_api', array() );
        return '';  //  it will already say "Please reload the page and try again in a couple of minutes."        
      } else {
        return func__http($aArgs);
      }      
      
    }
    curl_close($hCurl);
  }

  return $response;
}

function get_cache_file($filename){
  global $cacheDir;  
  
  if (!file_exists($cacheDir.$filename)) {
    return array();
  }

  $contents  = '';
  $file = fopen($cacheDir.$filename,"r");
  
  if (flock($file,LOCK_SH))
  {
    $contents = file_get_contents($cacheDir.$filename);
    if ($contents) {
      $contents = unserialize($contents);
    } else {
      $contents = array();
    }
    flock($file,LOCK_UN);
  }else{
    //not in cache
    //echo json_encode( array( 'error' => 'File lock read error' ) );
  }
  
  if( $file ) fclose($file);
  
  return $contents;
}

function set_cache_file($filename,$data,$video_id = null){
  global $cacheDir;
  $file = fopen($cacheDir.$filename,"w+");
  if (flock($file,LOCK_EX))
  {
    fwrite($file,serialize($data));   
    flock($file,LOCK_UN);
  }else{
    return false;
  }
  fclose($file);
  return true;
}



function plugins_url(){
  $ulr = $_SERVER['HTTP_ORIGIN'].$_SERVER['REQUEST_URI'];

  preg_match('/.*wp-content/',$ulr,$result);
  
  return $result[0] . '/cache/';
}

function get_vimeo_access_token(){
  global $pathMatch, $pregDirSeparator;
  static $keyDefined = null;

  if ($keyDefined !== null) {
    return $keyDefined;
  }

  $dir = str_replace('wp-content'.DIRECTORY_SEPARATOR,'',$pathMatch[0]);
  if(!file_exists($dir.'wp-config.php')){
    $dir = preg_replace('/'.$pregDirSeparator.'[^'.$pregDirSeparator.']*$/','',$dir);
    if(!file_exists($dir.'wp-config.php'))
      die;
  }
  $confg = file_get_contents($dir.'wp-config.php');
  
  if(!preg_match('/define.*FV_PLAYER_VIMEO_KEY[^;]*;/',$confg,$matches)){
    die;
  };
  eval ($matches[0]);
  
  $keyDefined = FV_PLAYER_VIMEO_KEY;
  return $keyDefined;
}
